/* ------------------------- trata um click sobre o canvas ------------------ */

var umClick = function(evento){
    var ponto = pegaPonto(evento);
    marcaPonto(ponto);
    if(objetoAtual.pontos.length > 1){
      var numPontos = objetoAtual.pontos.length;
      var pontoIni = objetoAtual.pontos[numPontos - 2];
      var pontoFim = objetoAtual.pontos[numPontos - 1];
      ligaPontos(pontoIni , pontoFim);
    };
};

/* ----------------------------- pega ponto --------------------------------- */

function pegaPonto (evento){
    var ponto = novoPonto();
    ponto.x = evento.pageX - canvas.offsetLeft;
    ponto.y = evento.pageY - canvas.offsetTop;
    objetoAtual.pontos.push(ponto);
    return ponto;
};

/* ----------------------------- renderiza o ponto ---------------------------*/

function marcaPonto (ponto){
    pincel.fillStyle = vetCores[listaObjetos.length];
    pincel.beginPath();
    pincel.arc(ponto.x , ponto.y , 3.14 , 0 , 2 * 3.14);
    pincel.fill();
};

/* ------------------------------ liga pontos ------------------------------- */

function ligaPontos(pontoIni , pontoFim){
    pincel.strokeStyle = vetCores[listaObjetos.length];
    pincel.beginPath();
    pincel.moveTo(pontoIni.x , pontoIni.y);
    pincel.lineTo(pontoFim.x , pontoFim.y);
    pincel.stroke();
};

/* --------------------------- cria novo objeto ----------------------------- */

function novoObjeto(){
  var objeto = {
    pontos : []
  };
  return objeto;
};

/* ------------------------- cria novo ponto -------------------------------- */

function novoPonto(){
  var ponto = {
    x : '' ,
    y : ''
  };
  return ponto;
};


/* ------------------- trabalha com evento de double click ------------------ */

var doisClicks = function(event){
    event.preventDefault();
    //var ultimoPonto = pegaPonto(event);
    //objetoAtual.pontos.pop();  //remove ponto repetido
    //objetoAtual.pontos.pop();  //remove ponto repetido
    ligaPontos(objetoAtual.pontos[0] , objetoAtual.pontos[objetoAtual.pontos.length - 1]);
    listaObjetos.push(objetoAtual);
    coloriObjeto(objetoAtual);
    objetoAtual = novoObjeto();
    numeroObjetosCompletos += 1;
};

/* --------------------- colori o objeto marcado ---------------------------- */

function coloriObjeto(objeto){
  pincel.fillStyle = vetRGBA[listaObjetos.length - 1];
  pincel.beginPath();
  objeto.pontos.forEach(function(ponto){
    pincel.lineTo(ponto.x , ponto.y);
  });
  pincel.fill();
};

/* -------------------------------- desfazer -------------------------------- */

var desfazer = function(event){
  event.preventDefault();
  pincel.clearRect(0, 0, canvas.width, canvas.height); // limpa o canvas
  if (objetoAtual.pontos.length === 0 && listaObjetos.length > 0) {  // trata caso de o objeto atual mnao ter mais pontos , sendo assim deve-se remover o ultimo ponto do objeto fechado anterior
    objetoAtual = listaObjetos.pop();
    numeroObjetosCompletos--;
  }else
    objetoAtual.pontos.pop(); //remove ultimo ponto
  remontaObjetos();
};

/* ------------------------------ remontaObjetos ---------------------------- */

function remontaObjetos(){
  recriaObjetosCompletos();
  recriaObjetoIncompleto();
};

/* ---------------------------- recriaObjetoCompleto ------------------------ */

function recriaObjetoIncompleto(objeto){
  var pontoAnterior = objetoAtual.pontos[0];
  objetoAtual.pontos.forEach(function(ponto){
    marcaPonto(ponto);
    ligaPontos(pontoAnterior , ponto);
    pontoAnterior = ponto;
  });
};

/* ------------------------- recriaObjetoInconpleto ------------------------- */

function recriaObjetosCompletos(){
  var corAtual = numeroObjetosCompletos;
  listaObjetos.forEach(function(objeto){
    var pontoAnterior = objeto.pontos[0];
    objeto.pontos.forEach(function(ponto){
      recriaPonto(ponto , corAtual);
      religaPontos(pontoAnterior , ponto , corAtual);
      pontoAnterior = ponto;
    });
    religaPontos(objeto.pontos[0] , objeto.pontos[objeto.pontos.length - 1] , corAtual);
    recoloriObjeto(objeto , corAtual);
    corAtual--;
  });
};

/* ---------------------------- colori objeto UNDO -------------------------- */

function recoloriObjeto(objeto , cor){
  pincel.fillStyle = vetRGBA[listaObjetos.length - cor];
  pincel.beginPath();
  objeto.pontos.forEach(function(ponto){
    pincel.lineTo(ponto.x , ponto.y);
  });
  pincel.fill();
}

/* ---------------------------- cria pontos UNDO ---------------------------- */

function recriaPonto(ponto , cor){
  pincel.fillStyle = vetCores[listaObjetos.length - cor];
  pincel.beginPath();
  pincel.arc(ponto.x , ponto.y , 3.14 , 0 , 2 * 3.14);
  pincel.fill();
}

/* --------------------------- religa pontos UNDO --------------------------- */

function religaPontos(pontoIni , pontoFim , cor){
  console.log('cor : ' + vetCores[listaObjetos.length - cor]);
  pincel.strokeStyle = vetCores[listaObjetos.length - cor];
  pincel.beginPath();
  pincel.moveTo(pontoIni.x , pontoIni.y);
  pincel.lineTo(pontoFim.x , pontoFim.y);
  pincel.stroke();
}
