/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package dao;

import conexao.ConnectionFactory;
import java.io.Serializable;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.Date;
import modelos.Forum;
import modelos.ForumProjeto;
import modelos.Paciente;
import modelos.Projeto;
import modelos.TipoUsuario;
import modelos.Usuario;

/**
 *
 * @author DanielDruszcz
 */
public class ForumDAO implements Serializable {
    
    public ArrayList<Forum> lista(){
        String sql = "select forum.id, forum.conteudo, forum.data_criac, forum.autor, usuario.nome "
                + "from forum "
                + "inner join usuario on usuario.id = forum.autor";
        try (Connection con = new ConnectionFactory().getConnection()){
            try (PreparedStatement stmt = con.prepareStatement(sql)){
                try (ResultSet rs = stmt.executeQuery()){
                    ArrayList<Forum> listaAdm = new ArrayList<Forum>();
                    while(rs.next()){
                        Forum forumBanco = new Forum();
                        forumBanco.setId(Long.parseLong(rs.getString("id")));
                        forumBanco.setAutor(pegaAutor(new Usuario(rs.getLong("autor")) , con));
                        forumBanco.setDataCriacao(new Date(rs.getTimestamp("data_criac").getTime()));
                        forumBanco.setConteudo(rs.getString("conteudo"));
                        listaAdm.add(forumBanco);
                    }
                    return listaAdm;
                } catch (Exception e) {
                    e.printStackTrace();
                    throw new RuntimeException("Erro ao setar os valores no paciente pego do banco");
                }
            } catch (Exception e) {
                e.printStackTrace();
                throw new RuntimeException("Erro ao preparar o Statement");
            }
        } catch (Exception e) {
            e.printStackTrace();
            throw new RuntimeException("Erro ao criar a conexao");
        }
    }
    
     public Forum cadastra(Forum forum){
        String sql = "INSERT INTO forum (conteudo , autor, data_criac) VALUES (? , ? , ?)";
        try (Connection con = new ConnectionFactory().getConnection()){
            con.setAutoCommit(false);
            try (PreparedStatement stmt = con.prepareStatement(sql , Statement.RETURN_GENERATED_KEYS)){
                java.sql.Timestamp timestamp = new java.sql.Timestamp(forum.getDataCriacao().getTime());
                stmt.setString(1, forum.getConteudo());
                stmt.setLong(2, forum.getAutor().getId());
                stmt.setTimestamp(3, timestamp);
                stmt.execute();
                try (ResultSet rs = stmt.getGeneratedKeys()){
                    if(rs.next())
                        forum.setId(rs.getInt("id"));
                    con.commit();
                    return forum;
                } catch (Exception e) {
                    con.rollback();
                    e.printStackTrace();
                    throw new RuntimeException("Erro ao pegar a chave gerada");
                }
            } catch (Exception e) {
                con.rollback();
                e.printStackTrace();
                throw new RuntimeException("Erro ao preparar o statement");
            }
        } catch (Exception e) {
            e.printStackTrace();
            throw new RuntimeException("Erro ao conectar com o banco");
        }
    }
     
     public ArrayList<ForumProjeto> lista(Projeto projeto){
        String sql = "select forum_projeto.id, forum_projeto.conteudo, forum_projeto.data_criac, forum_projeto.autor, usuario.nome "
                + "from forum_projeto "
                + "inner join usuario on usuario.id = forum_projeto.autor "
                + "where forum_projeto.projeto = ?";
        try (Connection con = new ConnectionFactory().getConnection()){
            try (PreparedStatement stmt = con.prepareStatement(sql)){
                stmt.setLong(1, projeto.getId());
                try (ResultSet rs = stmt.executeQuery()){
                    ArrayList<ForumProjeto> listaProjeto = new ArrayList<ForumProjeto>();
                    while(rs.next()){
                        ForumProjeto forumBanco = new ForumProjeto();
                        forumBanco.setId(Long.parseLong(rs.getString("id")));
                        forumBanco.setAutor(pegaAutor(new Usuario(rs.getLong("autor")) , con));
                        forumBanco.setDataCriacao(new Date(rs.getTimestamp("data_criac").getTime()));
                        forumBanco.setConteudo(rs.getString("conteudo"));
                        listaProjeto.add(forumBanco);
                    }
                    return listaProjeto;
                } catch (Exception e) {
                    e.printStackTrace();
                    throw new RuntimeException("Erro ao setar os valores no paciente pego do banco");
                }
            } catch (Exception e) {
                e.printStackTrace();
                throw new RuntimeException("Erro ao preparar o Statement");
            }
        } catch (Exception e) {
            e.printStackTrace();
            throw new RuntimeException("Erro ao criar a conexao");
        }
    }
     
      public Forum cadastra(ForumProjeto forum){
        String sql = "INSERT INTO forum_projeto (conteudo , autor,projeto, data_criac) VALUES (? , ? , ?, ?)";
        try (Connection con = new ConnectionFactory().getConnection()){
            con.setAutoCommit(false);
            try (PreparedStatement stmt = con.prepareStatement(sql , Statement.RETURN_GENERATED_KEYS)){
                 java.sql.Timestamp timestamp = new java.sql.Timestamp(forum.getDataCriacao().getTime());
                stmt.setString(1, forum.getConteudo());
                stmt.setLong(2, forum.getAutor().getId());
                stmt.setLong(3, forum.getIdprojeto());
                stmt.setTimestamp(4, timestamp);
                stmt.execute();
                try (ResultSet rs = stmt.getGeneratedKeys()){
                    if(rs.next())
                        forum.setId(rs.getInt("id"));
                    con.commit();
                    return forum;
                } catch (Exception e) {
                    con.rollback();
                    e.printStackTrace();
                    throw new RuntimeException("Erro ao pegar a chave gerada");
                }
            } catch (Exception e) {
                con.rollback();
                e.printStackTrace();
                throw new RuntimeException("Erro ao preparar o statement");
            }
        } catch (Exception e) {
            e.printStackTrace();
            throw new RuntimeException("Erro ao conectar com o banco");
        }
    }
      
       private Usuario pegaAutor(Usuario usuario , Connection con){
        String sql = "select u.nome , \n" +
                     "       u.sobrenome ,\n" +
                     "       u.email ,\n" +
                     "       u.ativo ,\n" +
                     "       tu.id ,\n" +
                     "       tu.tipo\n" +
                     "from usuario u\n" +
                     "     inner join tipo_usuario tu on tu.id = u.tipo\n" +
                     "where u.id = ?";
        try (PreparedStatement stmt = con.prepareStatement(sql)){
            stmt.setLong(1, usuario.getId());
            try (ResultSet rs = stmt.executeQuery()){
                if(rs.next()){
                    usuario.setNome(rs.getString("nome"));
                    usuario.setSobrenome(rs.getString("sobrenome"));
                    usuario.setEmail(rs.getString("email"));
                    TipoUsuario tipo = new TipoUsuario();
                    tipo.setId(rs.getLong("id"));
                    tipo.setTipo(rs.getString("tipo"));
                    usuario.setTipoUsuario(tipo);
                    return usuario;
                }
                throw new RuntimeException();
            } catch (Exception e) {
                e.printStackTrace();
                throw new RuntimeException();
            }
        } catch (Exception e) {
            e.printStackTrace();
            throw new RuntimeException();
        }
    }
       
        public Forum edita(Forum forum){
        String sql = "UPDATE forum SET conteudo = ?, data_criac = ? WHERE id = ?";
        try (Connection con = new ConnectionFactory().getConnection()){
            con.setAutoCommit(false);
            try (PreparedStatement stmt = con.prepareStatement(sql)){
                stmt.setString(1, forum.getConteudo());
                stmt.setDate(2, new java.sql.Date(forum.getDataCriacao().getTime()));
                stmt.setLong(3, forum.getId());
                stmt.execute();
                con.commit();
                return forum;
            } catch (Exception e) {
                e.printStackTrace();
                throw new RuntimeException();
            }
        } catch (Exception e) {
            e.printStackTrace();
            throw new RuntimeException();
        }
    }
        
        public Forum remove(Forum forum){
        String sql = "DELETE FROM forum WHERE id = ?";
        try (Connection con = new ConnectionFactory().getConnection()){
            con.setAutoCommit(false);
            try (PreparedStatement stmt = con.prepareStatement(sql)){
                stmt.setLong(1, forum.getId());
                stmt.execute();
                con.commit();
                return forum;
            } catch (Exception e) {
                e.printStackTrace();
                throw new RuntimeException();
            }
        } catch (Exception e) {
            e.printStackTrace();
            throw new RuntimeException();
        }
    }
        
        public ForumProjeto edita(ForumProjeto forum){
        String sql = "UPDATE forum_projeto SET conteudo = ?, data_criac = ? WHERE id = ?";
        try (Connection con = new ConnectionFactory().getConnection()){
            con.setAutoCommit(false);
            try (PreparedStatement stmt = con.prepareStatement(sql)){
                stmt.setString(1, forum.getConteudo());
                stmt.setDate(2, new java.sql.Date(forum.getDataCriacao().getTime()));
                stmt.setLong(3, forum.getId());
                stmt.execute();
                con.commit();
                return forum;
            } catch (Exception e) {
                e.printStackTrace();
                throw new RuntimeException();
            }
        } catch (Exception e) {
            e.printStackTrace();
            throw new RuntimeException();
        }
    }
        
        public ForumProjeto remove(ForumProjeto forum){
        String sql = "DELETE FROM forum_projeto WHERE id = ?";
        try (Connection con = new ConnectionFactory().getConnection()){
            con.setAutoCommit(false);
            try (PreparedStatement stmt = con.prepareStatement(sql)){
                stmt.setLong(1, forum.getId());
                stmt.execute();
                con.commit();
                return forum;
            } catch (Exception e) {
                e.printStackTrace();
                throw new RuntimeException();
            }
        } catch (Exception e) {
            e.printStackTrace();
            throw new RuntimeException();
        }
    }
       
}
