/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package dao;

import conexao.ConnectionFactory;
import java.io.Serializable;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;
import modelos.Exame;
import modelos.ImagemOriginal;
import modelos.Usuario;

/**
 *
 * @author DanielDruszcz
 */
public class ImagemDAO implements Serializable {
    
     public void cadastra(List<ImagemOriginal> imagens){
        String sql = "INSERT INTO imagem_original (exame , local_imagem , local_png , corte, name)"
                + "VALUES (? , ? , ? , ?, ?)";
        try (Connection con = new ConnectionFactory().getConnection()){
            con.setAutoCommit(false);
            try (PreparedStatement stmt = con.prepareStatement(sql , Statement.RETURN_GENERATED_KEYS)){
                for(ImagemOriginal imagem: imagens){
                stmt.setLong(1, imagem.getExame().getId());
                stmt.setString(2, imagem.getLocalImagem());
                stmt.setString(3, imagem.getLocalPng());
                stmt.setLong(4, imagem.getCorte());
                stmt.setString(5, imagem.getNome());
                stmt.execute();
                }
                con.commit();
            } catch (Exception e) {
                e.printStackTrace();
                throw new RuntimeException();
            }
        } catch (Exception e) {
            e.printStackTrace();
            throw new RuntimeException();
        }
    }
     
     public List<ImagemOriginal> listaImagensExame(Exame exame){
       String sql = "SELECT imagem_original.id, imagem_original.local_png, imagem_original.name, "
               + "imagem_original.local_imagem FROM imagem_original "
                + "WHERE imagem_original.exame = ? order by imagem_original.name asc;";
        try (Connection con = new ConnectionFactory().getConnection()) {
            con.setAutoCommit(false);
            try (PreparedStatement stmt = con.prepareStatement(sql)) {
                stmt.setLong(1, exame.getId());
                try (ResultSet rs = stmt.executeQuery()) {
                    List<ImagemOriginal> lista = new ArrayList<>();
                    while (rs.next()) {
                        ImagemOriginal imagem = new ImagemOriginal();
                        imagem.setId(rs.getInt("id"));
                        imagem.setLocalPng(rs.getString("local_png"));
                        imagem.setNome(rs.getString("name"));
                        imagem.setLocalImagem(rs.getString("local_imagem"));
                        lista.add(imagem);
                    }
                    return lista;
                } catch (Exception e) {
                    e.printStackTrace();
                    throw new RuntimeException();
                }
            } catch (Exception e) {
                e.printStackTrace();
                throw new RuntimeException();
            }
           } catch (Exception e) {
                e.printStackTrace();
                throw new RuntimeException();
            }
        }   
}
