/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package dao;

import conexao.ConnectionFactory;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;
import modelos.ImagemOriginal;
import modelos.ImagemSegmentada;
import modelos.TipoUsuario;
import modelos.Usuario;

/**
 *
 * @author DanielDruszcz
 */
public class ImagemSegmentadaDAO {
    public long cadastra(ImagemSegmentada imagemSegmentada){
        String sql = "insert into imagem_segmentada (usuario , imagem_original , comentario) VALUES (? , ? , ?);";
        try (Connection con = new ConnectionFactory().getConnection()){
            con.setAutoCommit(false);
            try (PreparedStatement stmt = con.prepareStatement(sql , Statement.RETURN_GENERATED_KEYS)){
                stmt.setLong(1, imagemSegmentada.getUsuario().getId());
                stmt.setLong(2, imagemSegmentada.getImagemOriginal().getId());
                stmt.setString(3, imagemSegmentada.getComentario());
                stmt.execute();
                con.commit();
                try (ResultSet rs = stmt.getGeneratedKeys()){
                    if(rs.next())
                        return rs.getLong("id");
                } catch (Exception e) {
                    con.rollback();
                    e.printStackTrace();
                }
            } catch (Exception e) {
                con.rollback();
                e.printStackTrace();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return 0;
    }
    private Usuario pegaUsuario(Usuario usuario , Connection con){
        String sql = "select u.nome , \n" +
                     "       u.sobrenome ,\n" +
                     "       u.email ,\n" +
                     "       u.ativo ,\n" +
                     "       tu.id ,\n" +
                     "       tu.tipo\n" +
                     "from usuario u\n" +
                     "     inner join tipo_usuario tu on tu.id = u.tipo\n" +
                     "where u.id = ?";
        try (PreparedStatement stmt = con.prepareStatement(sql)){
            stmt.setLong(1, usuario.getId());
            try (ResultSet rs = stmt.executeQuery()){
                if(rs.next()){
                    usuario.setNome(rs.getString("nome"));
                    usuario.setSobrenome(rs.getString("sobrenome"));
                    usuario.setEmail(rs.getString("email"));
                    usuario.setAtivo(rs.getBoolean("ativo"));
                    TipoUsuario tipo = new TipoUsuario();
                    tipo.setId(rs.getLong("id"));
                    tipo.setTipo(rs.getString("tipo"));
                    usuario.setTipoUsuario(tipo);
                    return usuario;
                }
                throw new RuntimeException();
            } catch (Exception e) {
                e.printStackTrace();
                throw new RuntimeException();
            }
        } catch (Exception e) {
            e.printStackTrace();
            throw new RuntimeException();
        }
    }
    
    private ImagemOriginal pegaImagemOriginal(ImagemOriginal imagem , Connection con){
        String sql = "select u.local_imagem , \n" +
                     "       u.local_png ,\n" +
                     "       u.id \n" +
                     "from imagem_original u\n" +
                     "where u.id = ?";
        try (PreparedStatement stmt = con.prepareStatement(sql)){
            stmt.setLong(1, imagem.getId());
            try (ResultSet rs = stmt.executeQuery()){
                if(rs.next()){
                    imagem.setId(rs.getLong("id"));
                    imagem.setLocalImagem(rs.getString("local_imagem"));
                    imagem.setLocalPng(rs.getString("local_png"));
                    return imagem;
                }
                throw new RuntimeException();
            } catch (Exception e) {
                e.printStackTrace();
                throw new RuntimeException();
            }
        } catch (Exception e) {
            e.printStackTrace();
            throw new RuntimeException();
        }
    }
    
     public List<ImagemSegmentada> listaImagensMarcadas(ImagemOriginal imagem){
          String sql = "SELECT id, usuario, comentario, imagem_original FROM imagem_segmentada where imagem_original = ?";
        try (Connection con = new ConnectionFactory().getConnection()){
            try (PreparedStatement stmt = con.prepareStatement(sql)){
                stmt.setLong(1, imagem.getId());
                try (ResultSet rs = stmt.executeQuery()){
                    List<ImagemSegmentada> lista = new ArrayList<>();
                    while(rs.next()){
                        ImagemSegmentada imgS = new ImagemSegmentada();
                        imgS.setId((long)rs.getInt("id"));
                        imgS.setUsuario(pegaUsuario(new Usuario(rs.getLong("usuario")) , con));
                        imgS.setComentario(rs.getString("comentario"));
                        imgS.setImagemOriginal(pegaImagemOriginal(new ImagemOriginal(rs.getLong("imagem_original")),con));
                        lista.add(imgS);
                    }
                    return lista;
                } catch (Exception e) {
                    e.printStackTrace();
                    throw new RuntimeException("Erro ao gerar a lista");
                }
            } catch (Exception e) {
                e.printStackTrace();
                throw new RuntimeException("Erro ao preparar o statement");
            }
        } catch (Exception e) {
            e.printStackTrace();
            throw new RuntimeException("Erro ao conectar");
        }
     }
     
     public ImagemSegmentada pegaDados(ImagemSegmentada imagem){
         String sql = "select u.email \"login\" ,\n" +
                      "       i.comentario \"comentario\"\n" +
                      "from imagem_segmentada i \n" +
                      "     inner join usuario u on u.id = i.usuario\n" +
                      "where i.id = ?";
         try (Connection con = new ConnectionFactory().getConnection()){
             try (PreparedStatement stmt = con.prepareStatement(sql)){
                 stmt.setLong(1, imagem.getId());
                 try (ResultSet rs = stmt.executeQuery()){
                     if(rs.next()){
                         ImagemSegmentada imagemSegmentada = new ImagemSegmentada();
                         imagemSegmentada.setComentario(rs.getString("comentario"));
                         Usuario usuario = new Usuario();
                         usuario.setEmail(rs.getString("login"));
                         imagemSegmentada.setUsuario(usuario);
                         return imagemSegmentada;
                     }
                 } catch (Exception e) {
                     e.printStackTrace();
                 }
             } catch (Exception e) {
                 e.printStackTrace();
             }
         } catch (Exception e) {
             e.printStackTrace();
         }
         return null;
     }
}
