/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package dao;

import conexao.ConnectionFactory;
import java.io.Serializable;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;
import modelos.Instituicao;
import modelos.Paciente;
import modelos.Usuario;

/**
 *
 * @author DanielDruszcz
 */
public class InstituicaoDAO implements Serializable {
    
     public Instituicao cadastra(Instituicao instituicao){
        String sql = "INSERT INTO instituicao (nome) VALUES (?)";
        try (Connection con = new ConnectionFactory().getConnection()){
            con.setAutoCommit(false);
            try (PreparedStatement stmt = con.prepareStatement(sql , Statement.RETURN_GENERATED_KEYS)){
                stmt.setString(1, instituicao.getNome());
                stmt.execute();
                try (ResultSet rs = stmt.getGeneratedKeys()){
                    if(rs.next()){
                        instituicao.setId(rs.getInt("id"));
                        con.commit();
                        return instituicao;
                    }
                    throw new RuntimeException();
                } catch (Exception e) {
                    e.printStackTrace();
                    throw new RuntimeException();
                }
            } catch (Exception e) {
                e.printStackTrace();
                throw new RuntimeException();
            }
        } catch (Exception e) {
            e.printStackTrace();
            throw new RuntimeException();
        }
    }
     
     public void remove(Instituicao instituicao){
        String sql = "DELETE FROM instituicao where id = ?";
        try (Connection con = new ConnectionFactory().getConnection()){
            con.setAutoCommit(false);
            try (PreparedStatement stmt = con.prepareStatement(sql , Statement.RETURN_GENERATED_KEYS)){
                stmt.setLong(1, instituicao.getId());
                stmt.execute();
                try (ResultSet rs = stmt.getGeneratedKeys()){
                    if(rs.next()){
                        instituicao.setId(rs.getInt("id"));
                        con.commit();
                    }
                } catch (Exception e) {
                    e.printStackTrace();
                    throw new RuntimeException();
                }
            } catch (Exception e) {
                e.printStackTrace();
                throw new RuntimeException();
            }
        } catch (Exception e) {
            e.printStackTrace();
            throw new RuntimeException();
        }
    }
     
     public List<Instituicao> lista(){
       String sql = "SELECT * FROM instituicao";
        try (Connection con = new ConnectionFactory().getConnection()){
            try (PreparedStatement stmt = con.prepareStatement(sql)){
                try (ResultSet rs = stmt.executeQuery()){
                    List<Instituicao> lista = new ArrayList<>();
                    while(rs.next()){
                        Instituicao inst = new Instituicao();
                        inst.setId((long)rs.getInt("id"));
                        inst.setNome(rs.getString("nome"));
                        lista.add(inst);
                    }
                    return lista;
                } catch (Exception e) {
                    e.printStackTrace();
                    throw new RuntimeException("Erro ao gerar a lista");
                }
            } catch (Exception e) {
                e.printStackTrace();
                throw new RuntimeException("Erro ao preparar o statement");
            }
        } catch (Exception e) {
            e.printStackTrace();
            throw new RuntimeException("Erro ao conectar");
        }
    }
}
