/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package dao;

import conexao.ConnectionFactory;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;
import modelos.ObjetoSegmentado;

/**
 *
 * @author joaofelipelopes
 */
public class ObjetoDAO {
    public void salvaMarcacoes(List<ObjetoSegmentado> objetos , long id_imagem_segmentada){
        String sql = "INSERT INTO marcacao (id_imagem_segmentada) VALUES (?)";
        try (Connection con = new ConnectionFactory().getConnection()){
            con.setAutoCommit(false);
            for(ObjetoSegmentado objeto : objetos){
                try (PreparedStatement stmt = con.prepareStatement(sql , Statement.RETURN_GENERATED_KEYS)){
                    stmt.setLong(1, id_imagem_segmentada);
                    stmt.execute();
                    con.commit();
                    try (ResultSet rs = stmt.getGeneratedKeys()){
                        if(rs.next())
                            new PontoDAO().cadastra(con , rs.getInt("id_marcacao") , objeto.getPontos());
                    } catch (Exception e) {
                        con.rollback();
                        e.printStackTrace();
                    }
                } catch (Exception e) {
                    con.rollback();
                    e.printStackTrace();
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    
    public List<ObjetoSegmentado> listaMarcacoes(int idImagem){
        String sql = "select id_marcacao\n" +
                     "from marcacao \n" +
                     "where id_imagem_segmentada = ?\n";
        try (Connection con = new ConnectionFactory().getConnection()){
            try (PreparedStatement stmt = con.prepareStatement(sql)){
                stmt.setInt(1, idImagem);
                try (ResultSet rs = stmt.executeQuery()){
                    List<ObjetoSegmentado> lista = new ArrayList<>();
                    while(rs.next()){
                        ObjetoSegmentado objeto = new ObjetoSegmentado();
                        int id_objeto = rs.getInt("id_marcacao");
                        objeto.setPontos(new PontoDAO().listaPontos(id_objeto, con));
                        lista.add(objeto);
                    }
                    return lista;
                } catch (Exception e) {
                    e.printStackTrace();
                }
            } catch (Exception e) {
                e.printStackTrace();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }
}
