/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package dao;

import conexao.ConnectionFactory;
import java.io.Serializable;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import modelos.Paciente;

/**
 *
 * @author joaofelipe
 */
public class PacienteDAO implements Serializable {
    
/* ----------------------------------- PEGA PACIENTE ------------------------ */
    
    public Paciente pega(Paciente paciente){
        String sql = "SELECT sexo ,\n" +
                     "       data_nasc\n" +
                     "       idade\n" +
                     "FROM paciente\n" +
                     "WHERE id = ?";
        try (Connection con = new ConnectionFactory().getConnection()){
            try (PreparedStatement stmt = con.prepareStatement(sql)){
                stmt.setLong(1,paciente.getId());
                try (ResultSet rs = stmt.executeQuery()){
                    Paciente pacienteBanco = new Paciente();
                    while(rs.next()){
                        pacienteBanco.setId(paciente.getId());
                        pacienteBanco.setSexo(rs.getString("sexo"));
                        pacienteBanco.setDataNasc(new Date(rs.getDate("data_nasc").getTime()));
                        pacienteBanco.setIdade(rs.getString("idade"));
                    }
                    return pacienteBanco;
                } catch (Exception e) {
                    e.printStackTrace();
                    throw new RuntimeException("Erro ao setar os valores no paciente pego do banco");
                }
            } catch (Exception e) {
                e.printStackTrace();
                throw new RuntimeException("Erro ao preparar o Statement");
            }
        } catch (Exception e) {
            e.printStackTrace();
            throw new RuntimeException("Erro ao criar a conexao");
        }
    }
    
/* ------------------------------- CADASTRA PACIENTE ------------------------ */
    
    public Paciente cadastra(Paciente paciente){
        System.out.println("here");
        String sql = "INSERT INTO paciente (sexo, idade , data_nasc) VALUES (?, ? , ?)";
        try (Connection con = new ConnectionFactory().getConnection()){
            con.setAutoCommit(false);
            try (PreparedStatement stmt = con.prepareStatement(sql , Statement.RETURN_GENERATED_KEYS)){
                stmt.setString(1, paciente.getSexo());
                stmt.setString(2, paciente.getIdade());
                if(paciente.getDataNasc() != null ){
                stmt.setDate(3, new java.sql.Date(paciente.getDataNasc().getTime()));
                }else{
                stmt.setDate(3, null);
                }
                stmt.execute();
                try (ResultSet rs = stmt.getGeneratedKeys()){
                    if(rs.next())
                        paciente.setId(rs.getInt("id"));
                    con.commit();
                    return paciente;
                } catch (Exception e) {
                    con.rollback();
                    e.printStackTrace();
                    throw new RuntimeException("Erro ao pegar a chave gerada");
                }
            } catch (Exception e) {
                con.rollback();
                e.printStackTrace();
                throw new RuntimeException("Erro ao preparar o statement");
            }
        } catch (Exception e) {
            e.printStackTrace();
            throw new RuntimeException("Erro ao conectar com o banco");
        }
    }
    
/* ------------------------------ LISTA ------------------------------------- */
    
    public List<Paciente> lista(){
        String sql = "SELECT id , sexo, idade , data_nasc FROM paciente";
        try (Connection con = new ConnectionFactory().getConnection()){
            try (PreparedStatement stmt = con.prepareStatement(sql)){
                try (ResultSet rs = stmt.executeQuery()){
                    List<Paciente> lista = new ArrayList<>();
                    while(rs.next()){
                        Paciente paciente = new Paciente();
                        paciente.setId((long)rs.getInt("id"));
                        paciente.setSexo(rs.getString("sexo"));
                        paciente.setIdade(rs.getString("idade"));
                        paciente.setDataNasc(rs.getDate("data_nasc"));
                        lista.add(paciente);
                    }
                    return lista;
                } catch (Exception e) {
                    e.printStackTrace();
                    throw new RuntimeException("Erro ao gerar a lista");
                }
            } catch (Exception e) {
                e.printStackTrace();
                throw new RuntimeException("Erro ao preparar o statement");
            }
        } catch (Exception e) {
            e.printStackTrace();
            throw new RuntimeException("Erro ao conectar");
        }
    }
}
