/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package dao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import modelos.Ponto;

/**
 *
 * @author joaofelipelopes
 */
public class PontoDAO {
    
    public void cadastra(Connection conexao , int idObjeto , List<Ponto> pontos) throws SQLException{
        String sql = "INSERT INTO ponto (eixo_x , eixo_y , ordem , id_marcacao) VALUES (? , ? , ? , ?)";
        for(Ponto ponto : pontos){
            try (PreparedStatement stmt = conexao.prepareStatement(sql)){
                stmt.setInt(1, ponto.getEixoX());
                stmt.setInt(2, ponto.getEixoY());
                stmt.setInt(3, ponto.getOrdem());
                stmt.setInt(4, idObjeto);
                stmt.execute();
                conexao.commit();
            } catch (Exception e) {
                conexao.rollback();
                e.printStackTrace();
            }
        }
    }
    
    public List<Ponto> listaPontos(int idObjeto , Connection con){
        String sql = "select p.eixo_x ,\n" +
                     "    p.eixo_y ,\n" +
                     "    p.ordem \n" +
                     "from marcacao ob\n" +
                     "  inner join ponto p on p.id_marcacao = ob.id_marcacao\n" +
                     "where ob.id_marcacao = ?\n" +
                     "order by p.id_marcacao , p.ordem";
        try (PreparedStatement stmt = con.prepareStatement(sql)){
            stmt.setInt(1, idObjeto);
            try (ResultSet rs = stmt.executeQuery()){
                List<Ponto> lista = new ArrayList<>();
                while(rs.next()){
                    Ponto p = new Ponto();
                    p.setEixoX(rs.getInt("eixo_x"));
                    p.setEixoY(rs.getInt("eixo_y"));
                    p.setOrdem(rs.getInt("ordem"));
                    lista.add(p);
                }
                return lista;
            } catch (Exception e) {
                e.printStackTrace();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }
    
}
