/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package dao;

import conexao.ConnectionFactory;
import java.io.Serializable;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;
import modelos.TipoExame;

/**
 *
 * @author joaofelipe
 */
public class TipoExameDAO implements Serializable {
    
/* --------------------------------- CADASTRA ------------------------------- */
    
    public TipoExame cadastra(TipoExame tipoExame){
        String sql = "INSERT INTO tipo_exame (tipo) VALUES (?);";
        try (Connection con = new ConnectionFactory().getConnection()){
            con.setAutoCommit(false);
            try (PreparedStatement stmt = con.prepareStatement(sql , Statement.RETURN_GENERATED_KEYS)){
                stmt.setString(1, tipoExame.getNome());
                stmt.execute();
                try (ResultSet rs = stmt.getGeneratedKeys()){
                    if(rs.next())
                        tipoExame.setId(rs.getInt("id"));
                    con.commit();
                    return tipoExame;
                } catch (Exception e) {
                    e.printStackTrace();
                    throw new RuntimeException("Erro ao pegar a chave gereda");
                }
            } catch (Exception e) {
                e.printStackTrace();
                throw new RuntimeException("Erro ao preparar o statement");
            }
        } catch (Exception e) {
            e.printStackTrace();
            throw new RuntimeException("Erro ao conectar");
        }
    }
    
/* ----------------------------------- LISTA -------------------------------- */
    
    public List<TipoExame> lista(){
        String sql = "SELECT id , tipo FROM tipo_exame";
        try (Connection con = new ConnectionFactory().getConnection()){
            try (PreparedStatement stmt = con.prepareStatement(sql)){
                try (ResultSet rs = stmt.executeQuery()){
                    List<TipoExame> lista = new ArrayList<>();
                    while(rs.next()){
                        TipoExame tipoExame = new TipoExame();
                        tipoExame.setId(rs.getLong("id"));
                        tipoExame.setNome(rs.getString("tipo"));
                        lista.add(tipoExame);
                    }
                    return lista;
                } catch (Exception e) {
                    e.printStackTrace();
                    throw new RuntimeException("Erro ao montar a lista");
                }
            } catch (Exception e) {
                e.printStackTrace();
                throw new RuntimeException("Erro ao preparar o statement");
            }
        } catch (Exception e) {
            e.printStackTrace();
            throw new RuntimeException("Erro ao conectar");
        }
    }
    
/* ------------------------------- REMOVE ----------------------------------- */
    
    public void remove(TipoExame tipoExame){
        String sql = "DELETE FROM tipo_exame WHERE id = ?";
        try (Connection con = new ConnectionFactory().getConnection()){
            con.setAutoCommit(false);
            try (PreparedStatement stmt = con.prepareStatement(sql)){
                stmt.setLong(1, tipoExame.getId());
                stmt.execute();
                con.commit();
            } catch (Exception e) {
                e.printStackTrace();
                throw new RuntimeException("Erro ao preparar o statement");
            }
        } catch (Exception e) {
            e.printStackTrace();
            throw new RuntimeException("Erro ao criar a conexao");
        }
    }
    
/* -------------------------------- PEGA ------------------------------------ */
    
    public TipoExame pega(TipoExame tipo){
        String sql = "SELECT tipo FROM tipo_exame WHERE id = ?";
        try (Connection con = new ConnectionFactory().getConnection()){
            try (PreparedStatement stmt = con.prepareStatement(sql)){
                stmt.setLong(1, tipo.getId());
                try (ResultSet rs = stmt.executeQuery()){
                    if(rs.next()){
                        TipoExame tipoExame = new TipoExame();
                        tipoExame.setId(tipo.getId());
                        tipoExame.setNome(rs.getString("tipo"));
                        return tipoExame;
                    }
                    throw new RuntimeException("Nao encontrado");
                } catch (Exception e) {
                    e.printStackTrace();
                    throw new RuntimeException();
                }
            } catch (Exception e) {
                e.printStackTrace();
                throw new RuntimeException();
            }
        } catch (Exception e) {
            e.printStackTrace();
            throw new RuntimeException();
        }
    }
    
}
