/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package modelos;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 *
 * @author joaofelipelopes
 */
public class Projeto implements Serializable{
    private long id;
    private String nome;
    private String descricao;
    private List<Instituicao> instituicoes;
    private List<Exame> exames;
    private Usuario moderador;
    private TipoProjeto tipo;
    private TipoVinculo tipov;
    private String situacaov;
    private String corv;
    private String situacao;
    private String cor;
    private boolean mostra;
    
    
    public Projeto(long id){
        this.id = id;
    }
    
    public Projeto() {
        this.exames = new ArrayList<>();
        this.instituicoes = new ArrayList<>();
    }
    
/* -------------------------------- GETTERS --------------------------------- */

    public long getId() {
        return id;
    }

    public String getNome() {
        return nome;
    }

    public String getDescricao() {
        return descricao;
    }

    public List<Instituicao> getInstituicoes() {
        return instituicoes;
    }

    public List<Exame> getExames() {
        return exames;
    }

    public Usuario getModerador() {
        return moderador;
    }

/* ------------------------------ SETTERS ----------------------------------- */

    public void setId(long id) {
        this.id = id;
    }

    public void setNome(String nome) {
        this.nome = nome;
    }

    public void setDescricao(String descricao) {
        this.descricao = descricao;
    }

    public void setInstituicoes(List<Instituicao> instituicoes) {
        this.instituicoes = instituicoes;
    }

    public void setExames(List<Exame> exames) {
        this.exames = exames;
    }

    public void setModerador(Usuario moderador) {
        this.moderador = moderador;
    }

    public TipoProjeto getTipo() {
        return tipo;
    }

    public void setTipo(TipoProjeto tipo) {
        this.tipo = tipo;
    }

    public String getSituacao() {
        return situacao;
    }

    public void setSituacao(String situacao) {
        this.situacao = situacao;
    }

    public String getCor() {
        return cor;
    }

    public void setCor(String cor) {
        this.cor = cor;
    }

    public TipoVinculo getTipov() {
        return tipov;
    }

    public void setTipov(TipoVinculo tipov) {
        this.tipov = tipov;
    }

    public String getSituacaov() {
        return situacaov;
    }

    public void setSituacaov(String situacaov) {
        this.situacaov = situacaov;
    }

    public String getCorv() {
        return corv;
    }

    public void setCorv(String corv) {
        this.corv = corv;
    }

    public boolean isMostra() {
        return mostra;
    }

    public void setMostra(boolean mostra) {
        this.mostra = mostra;
    }
    
    
    
   
    
/* --------------------------------- OUTROS METODOS ------------------------- */

    @Override
    public String toString() {
        return "Projeto{" + "id=" + id + ", nome=" + nome + ", descricao=" + descricao + ", instituicoes=" + instituicoes + ", exames=" + exames + ", moderador=" + moderador + '}';
    }

    @Override
    public int hashCode() {
        int hash = 3;
        hash = 59 * hash + (int) (this.id ^ (this.id >>> 32));
        hash = 59 * hash + Objects.hashCode(this.nome);
        hash = 59 * hash + Objects.hashCode(this.descricao);
        hash = 59 * hash + Objects.hashCode(this.instituicoes);
        hash = 59 * hash + Objects.hashCode(this.exames);
        hash = 59 * hash + Objects.hashCode(this.moderador);
        return hash;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final Projeto other = (Projeto) obj;
        if (this.id != other.id) {
            return false;
        }
        return true;
    }
    
    
    
}
