/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package modelos;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;
import javax.validation.constraints.Pattern;

/**
 *
 * @author joaofelipelopes
 */
public class Usuario implements Serializable{
    private long id;
    @Pattern(regexp="^[[ ]|\\p{L}*]+$", message = "Seu nome não pode conter caracteres especiais!")
    private String nome;
    @Pattern(regexp="^[[ ]|\\p{L}*]+$", message = "Seu sobrenome não pode conter caracteres especiais!")
    private String sobrenome;
    private String email;
    private String senha;
    private String situacao;
    private String corS;
    private boolean mostraU;
    private TipoUsuario tipoUsuario;
    private boolean ativo;
    private List<Instituicao> instituicoes;
    private List<Projeto> projetos;
    private List<Exame> exames;
    private List<ImagemSegmentada> imagensSegmentadas;

    public Usuario() {
        this.instituicoes = new ArrayList<>();
        this.projetos = new ArrayList<>();
        this.exames = new ArrayList<>();
        this.imagensSegmentadas = new ArrayList<>();
    }

    public Usuario(long id) {
        this.id = id;
        this.instituicoes = new ArrayList<>();
        this.projetos = new ArrayList<>();
        this.exames = new ArrayList<>();
        this.imagensSegmentadas = new ArrayList<>();
    }
    
    
    
/* -------------------------------- GETTERS --------------------------------- */

    public long getId() {
        return id;
    }

    public String getNome() {
        return nome;
    }

    public String getSobrenome() {
        return sobrenome;
    }

    public String getEmail() {
        return email;
    }

    public String getSenha() {
        return senha;
    }

    public TipoUsuario getTipoUsuario() {
        return tipoUsuario;
    }

    public List<Instituicao> getInstituicoes() {
        return instituicoes;
    }

    public List<Projeto> getProjetos() {
        return projetos;
    }

    public List<Exame> getExames() {
        return exames;
    }

    public List<ImagemSegmentada> getImagensSegmentadas() {
        return imagensSegmentadas;
    }
    
/* -------------------------------- SETTERS --------------------------------- */

    public void setId(long id) {
        this.id = id;
    }

    public void setNome(String nome) {
        this.nome = nome;
    }

    public void setSobrenome(String sobrenome) {
        this.sobrenome = sobrenome;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public void setSenha(String senha) {
        this.senha = senha;
    }

    public void setTipoUsuario(TipoUsuario tipoUsuario) {
        this.tipoUsuario = tipoUsuario;
    }

    public void setInstituicoes(List<Instituicao> instituicoes) {
        this.instituicoes = instituicoes;
    }

    public void setProjetos(List<Projeto> projetos) {
        this.projetos = projetos;
    }

    public void setExames(List<Exame> exames) {
        this.exames = exames;
    }

    public void setImagensSegmentadas(List<ImagemSegmentada> imagensSegmentadas) {
        this.imagensSegmentadas = imagensSegmentadas;
    }

    public boolean isAtivo() {
        return ativo;
    }

    public void setAtivo(boolean ativo) {
        this.ativo = ativo;
    }

    public String getSituacao() {
        return situacao;
    }

    public void setSituacao(String situacao) {
        this.situacao = situacao;
    }

    public String getCorS() {
        return corS;
    }

    public void setCorS(String corS) {
        this.corS = corS;
    }

    public boolean isMostraU() {
        return mostraU;
    }

    public void setMostraU(boolean mostraU) {
        this.mostraU = mostraU;
    }
    
    

/* ----------------------------------- OUTROS METODOS ----------------------- */

    @Override
    public String toString() {
        return "Usuario{" + "id=" + id + ", nome=" + nome + ", sobrenome=" + sobrenome + ", email=" + email + ", senha=" + senha + ", tipoUsuario=" + tipoUsuario + ", instituicoes=" + instituicoes + ", projetos=" + projetos + ", exames=" + exames + ", imagensSegmentadas=" + imagensSegmentadas + '}';
    }

    @Override
    public int hashCode() {
        int hash = 3;
        hash = 97 * hash + (int) (this.id ^ (this.id >>> 32));
        hash = 97 * hash + Objects.hashCode(this.nome);
        hash = 97 * hash + Objects.hashCode(this.sobrenome);
        hash = 97 * hash + Objects.hashCode(this.email);
        hash = 97 * hash + Objects.hashCode(this.senha);
        hash = 97 * hash + Objects.hashCode(this.tipoUsuario);
        hash = 97 * hash + Objects.hashCode(this.instituicoes);
        hash = 97 * hash + Objects.hashCode(this.projetos);
        hash = 97 * hash + Objects.hashCode(this.exames);
        hash = 97 * hash + Objects.hashCode(this.imagensSegmentadas);
        return hash;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final Usuario other = (Usuario) obj;
        if (this.id != other.id) {
            return false;
        }
        return true;
    }
    
    public void adicionaInstituicao(Instituicao instituicao){
        boolean result = true;
        for(Instituicao insti : this.instituicoes){
            if(instituicao.getId() == insti.getId()){
                result = false; 
                break;
            }
        }
        if(result) this.instituicoes.add(instituicao);
    }
    
    
    
}
