/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package web.beans;


import java.util.ArrayList;
import java.util.List;
import javax.annotation.PostConstruct;
import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ViewScoped;
import javax.faces.context.FacesContext;
import modelos.Projeto;
import org.primefaces.event.SelectEvent;
import org.primefaces.model.DualListModel;
import servicoimpl.ServicoProjetoImpl;


/**
 *
 * @author DanielDruszcz
 */
@ViewScoped
@ManagedBean(name = "aprovarprojeto")
public class BeanAprovaProjeto {
    
     private DualListModel<Projeto> projetos;
     private Projeto projetoSelecionado;
    
    @PostConstruct
    public void init() {
        projetoSelecionado = new Projeto();
        ServicoProjetoImpl serv = new ServicoProjetoImpl();
        List<Projeto> projetoswt = serv.listaProjetosInvalidos();
        List<Projeto> projetossl = new ArrayList<Projeto>();
        projetos = new DualListModel<Projeto>(projetoswt, projetossl);
    }
    
    public DualListModel<Projeto> getProjetos() {
        return projetos;
    }

    public void setProjetos(DualListModel<Projeto> projetos) {
        this.projetos = projetos;
    }

    public Projeto getProjetoSelecionado() {
        return projetoSelecionado;
    }

    public void setProjetoSelecionado(Projeto projetoSelecionado) {
        this.projetoSelecionado = projetoSelecionado;
    }
    
    
    public void aprovar(){
       
        try{
        ServicoProjetoImpl serv = new ServicoProjetoImpl();
        for(int i = 0; i < projetos.getTarget().size(); i++){
        serv.ativa(projetos.getTarget().get(i));
        }
        FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_INFO, 
                                        "Projetos ativados!", "Os projetos selecionados foram ativados com sucesso!"));
        projetos.getTarget().clear();
        }catch (Exception e){
        FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_FATAL, 
                                        "Ocorreu uma falha grave!", "Falha ao aprovar, contate o analista responsável!"));
            e.printStackTrace();;
        }
    }
    public void reprovar(){
        try{
        ServicoProjetoImpl serv = new ServicoProjetoImpl();
        for(int i = 0; i < projetos.getTarget().size(); i++){
        serv.reprova(projetos.getTarget().get(i));
        }
        projetos.getTarget().clear();
        FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_INFO, 
                                        "Projetos reprovados!", "Os projetos selecionados foram removidos com sucesso!"));
        }catch (Exception e){
        FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_FATAL, 
                                        "Ocorreu uma falha grave!", "Falha ao reprovar, contate o analista responsável!"));
            e.printStackTrace();;
        }
    }
    public void onSelect(SelectEvent event) {
        projetoSelecionado = (((Projeto)event.getObject()));
    }
}
