package web.beans;


import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import javax.annotation.PostConstruct;
import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;
import javax.faces.bean.ViewScoped;
import javax.faces.context.FacesContext;
import modelos.Usuario;
import org.primefaces.event.SelectEvent;

import org.primefaces.model.DualListModel;
import servicoimpl.ServicoUsuarioImpl;

 
@SessionScoped
@ManagedBean
(name = "aprovar")
public class BeanAprovaUser implements Serializable{

    private DualListModel<Usuario> users;
    private Usuario usuarioSelecionado;
    
    @PostConstruct
    public void init() {
        usuarioSelecionado = new Usuario();
        ServicoUsuarioImpl serv = new ServicoUsuarioImpl();
        List<Usuario> userswt = serv.listaUsuariosInvalidos();
        List<Usuario> userssl = new ArrayList<>();
        users = new DualListModel<Usuario>(userswt, userssl);
    }

    public Usuario getUsuarioSelecionado() {
        return usuarioSelecionado;
    }

    public void setUsuarioSelecionado(Usuario usuarioSelecionado) {
        this.usuarioSelecionado = usuarioSelecionado;
    }
    
 
    public DualListModel<Usuario> getUsers() {
        return users;
    }

    public void setUsers(DualListModel<Usuario> users) {
        this.users = users;
    }
    
    public void aprovar(){
        try{
        ServicoUsuarioImpl serv = new ServicoUsuarioImpl();
        for(int i = 0; i < users.getTarget().size(); i++){
        serv.ativa(users.getTarget().get(i));
        }
        FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_INFO, 
                                        "Usuários ativados!", "Os usuários selecionados foram ativados com sucesso!"));
        users.getTarget().clear();
        }catch (Exception e){
        FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_FATAL, 
                                        "Ocorreu uma falha grave!", "Falha ao aprovar, contate o analista responsável!"));
            e.printStackTrace();;
        }
    }
    
    public void onSelect(SelectEvent event) {
        usuarioSelecionado = (((Usuario)event.getObject()));
    }
    public void reprovar(){
       try{
       ServicoUsuarioImpl serv = new ServicoUsuarioImpl();
       for(int i = 0; i < users.getTarget().size(); i++){
        serv.remove(users.getTarget().get(i));
       }
        FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_WARN, 
                                        "Usuários reprovados!", "Os usuários selecionados foram removidos com sucesso!"));        users.getTarget().clear();
        }catch (Exception e){
        FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_FATAL, 
                "Ocorreu uma falha grave!", "Falha ao reprovar, contate o analista responsável!"));
            e.printStackTrace();;
        }
        
    }
}
