/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package web.beans;

import java.util.ArrayList;
import java.util.List;
import javax.annotation.PostConstruct;
import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ViewScoped;
import javax.faces.context.FacesContext;
import modelos.Projeto;
import modelos.Usuario;
import servicoimpl.ServicoProjetoImpl;
import servicoimpl.ServicoUsuarioImpl;
import web.utilidades.SessionContext;

/**
 *
 * @author DanielDruszcz
 */
@ViewScoped
@ManagedBean (name = "atdt")
public class BeanAtivarReprovarProj {
    private List<Projeto> projetos;
    private Projeto selectedProject;
    private Usuario novoMod;
    private List<Usuario> usersP;
    
    @PostConstruct
    public void init() {
        try{
        projetos = new ArrayList<Projeto>();
        selectedProject = new Projeto();
        novoMod = new Usuario();
        ServicoProjetoImpl serv = new ServicoProjetoImpl();
        projetos = serv.listaProjetosGerais();
        }catch (Exception e){
            e.printStackTrace();
        }
    }
    
    public void ativar(Projeto projeto){
        try{
        if(projeto.getModerador().isAtivo()){
        ServicoProjetoImpl serv = new ServicoProjetoImpl();
        projetos.remove(projeto);
        Projeto n = serv.ativa(projeto);
        n.setMostra(true);
        projetos.add(n);
        FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_INFO, 
                                        "Projetos ativados!", "O projeto foi ativado com sucesso!"));
        }else{
        FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_WARN, 
                                        "Impossivel ativar!", "O moderador deste projeto encontra-se inativo,"
                                                + "altere o moderador ou ative-o!"));    
        }
        }catch (Exception e){
        FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_FATAL, 
                                        "Ocorreu uma falha grave!", "Falha ao aprovar, contate o analista responsável!"));
            e.printStackTrace();;
        }
    }
    
    public void desativar(Projeto projeto){
         try{
        ServicoProjetoImpl serv = new ServicoProjetoImpl();
        projetos.remove(projeto);
        Projeto n = serv.desativa(projeto);
        n.setMostra(false);
        projetos.add(n);
        FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_INFO, 
                                        "Projetos desativados!", "O projeto foi desativado com sucesso!"));
        }catch (Exception e){
        FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_FATAL, 
                                        "Ocorreu uma falha grave!", "Falha ao aprovar, contate o analista responsável!"));
            e.printStackTrace();;
        }
    }
    
    public void atualizarMod(){
        ServicoProjetoImpl serv = new ServicoProjetoImpl();
        if(novoMod.isAtivo()){
        projetos.remove(selectedProject);
        selectedProject.setModerador(novoMod);
        Projeto novo = serv.atualizaMod(selectedProject);
        projetos.add(novo);
        FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_INFO, 
                                        "Moderador atualizado!", "O moderador do projeto foi alterado!"));
        }else{
          FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_WARN, 
                                        "Impossível atualizar!", "O usuário selecionado encontra-se inativo!"));   
        }
    }

    public List<Projeto> getProjetos() {
        return projetos;
    }

    public void setProjetos(List<Projeto> projetos) {
        this.projetos = projetos;
    }

    public Projeto getSelectedProject() {
        return selectedProject;
    }

    public void setSelectedProject(Projeto selectedProject) {
        usersP = new ArrayList<>();
        ServicoProjetoImpl serv = new ServicoProjetoImpl();
        usersP = serv.listaUsuariosProjeto(selectedProject);
        this.selectedProject = selectedProject;
    }

    public List<Usuario> getUsersP() {
        return usersP;
    }

    public void setUsersP(List<Usuario> usersP) {
        this.usersP = usersP;
    }

    public Usuario getNovoMod() {
        return novoMod;
    }

    public void setNovoMod(Usuario novoMod) {
        this.novoMod = novoMod;
    }
    
    
    
}
