package web.beans;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import javax.annotation.PostConstruct;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ViewScoped;
import modelos.Instituicao;
import modelos.TipoUsuario;
import modelos.Usuario;
import org.primefaces.event.FlowEvent;
import servicoimpl.ServicoInstituicaoImpl;
import servicoimpl.ServicoUsuarioImpl;
import web.utilidades.JSFUtil;
 
@ManagedBean(name = "cadastro")
@ViewScoped
public class BeanCadastro implements Serializable{
     
  
    private Usuario usuario;
    private String alerta;
    private String email;
    private String email2;
    private List<Instituicao> instituicoes;
    private boolean validaE = false;
    
    @PostConstruct
    private void init(){
        instituicoes = new ArrayList<>();
        ServicoInstituicaoImpl serv = new ServicoInstituicaoImpl();
        instituicoes = serv.lista();
        usuario = new Usuario();
    }
    
   

    public List<Instituicao> getInstituicoes() {
        return instituicoes;
    }

    public void setInstituicoes(List<Instituicao> instituicoes) {
        this.instituicoes = instituicoes;
    }


    public String getAlerta() {
        return alerta;
    }

    public void setAlerta(String alerta) {
        this.alerta = alerta;
    }

    public Usuario getUsuario() {
        return usuario;
    }

    public void setUsuario(Usuario usuario) {
        this.usuario = usuario;
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public String getEmail2() {
        return email2;
    }

    public void setEmail2(String email2) {
        this.email2 = email2;
    }
       
   
    public String validaEmail(){
        if(!email.equals(email2)){
            validaE = true;
            JSFUtil.addErrorMessage("Emails incompatíveis!!");
            return "";
        }else{
            if(email.contains("@")){
                if(email.contains(".com")){
                    validaE = false;
                    ServicoUsuarioImpl serv = new ServicoUsuarioImpl();
                    if(serv.consultaEmail(email) == 0){
                         usuario.setEmail(email);
                         validaE = false;
                         return "";
                    }else{
                         validaE = true;
                         JSFUtil.addErrorMessage("Este e-mail já esta cadastrado em nossa base!");
                         return "";
                    }
                }else{
                 validaE = true;
                JSFUtil.addErrorMessage("Isto não é um e-mail!");
                return "";
                }
            }else{
                validaE = true;
                JSFUtil.addErrorMessage("Isto não é um e-mail!");
                return "";
            }
        }
    }
    
    public void cadastrar() {
        ServicoUsuarioImpl serv = new ServicoUsuarioImpl();
        TipoUsuario t = new TipoUsuario();
        t.setId(0);
        usuario.setTipoUsuario(t);
        usuario = serv.cadastra(usuario);
        if(usuario != null){
        JSFUtil.addInfoMessage("Sua solicitação foi registrada. Aguarde a validação do ADM.");
        usuario = new Usuario();
        email = null;
        email2 = null;
        }else{
         JSFUtil.addErrorMessage("Ocorreu um erro no seu cadastro!");
        }
    }
    
    public void cadastrarA() {
        ServicoUsuarioImpl serv = new ServicoUsuarioImpl();
        TipoUsuario t = new TipoUsuario();
        t.setId(2);
        usuario.setTipoUsuario(t);
        usuario = serv.cadastra(usuario);
        if(usuario != null){
        JSFUtil.addInfoMessage("Cadastro realizado com sucesso.");
        usuario = new Usuario();
        email = null;
        email2 = null;
        }else{
         JSFUtil.addErrorMessage("Ocorreu um erro no seu cadastro!");
        }
    }
    
    public String onFlowProcess(FlowEvent event) {
        if(validaE == false){
            return event.getNewStep();
        }else{
            JSFUtil.addErrorMessage("Você ainda precisa corrigir alguns campos!");
            return event.getOldStep();
        }
    }
}