/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package web.beans;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import javax.annotation.PostConstruct;
import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ViewScoped;
import javax.faces.context.FacesContext;
import modelos.Forum;
import modelos.Usuario;
import org.primefaces.event.RowEditEvent;
import servicoimpl.ServicoForumImpl;
import web.utilidades.SessionContext;

/**
 *
 * @author DanielDruszcz
 */
@ViewScoped
@ManagedBean
(name = "infohome")
public class BeanHome implements Serializable{
    
    private ArrayList<Forum> infos;
    private Forum novaInfo = null;
    private String novoConteudo;
    
     @PostConstruct
    public void init() {
        ServicoForumImpl serv = new ServicoForumImpl();
        infos = new ArrayList<Forum>();
        infos = serv.lista();
    }

    public ArrayList<Forum> getInfos() {
        return infos;
    }

    public void setInfos(ArrayList<Forum> infos) {
        this.infos = infos;
    }

    public Forum getNovaInfo() {
        return novaInfo;
    }

    public void setNovaInfo(Forum novaInfo) {
        this.novaInfo = novaInfo;
    }

    public String getNovoConteudo() {
        return novoConteudo;
    }

    public void setNovoConteudo(String novoConteudo) {
        this.novoConteudo = novoConteudo;
    }
    
    
    
    public void gravarInfo(){
        if(novoConteudo != null && !novoConteudo.isEmpty()){
        novaInfo = new Forum();
        novaInfo.setAutor(((Usuario)SessionContext.getInstance().getAttribute("usuarioLogadoS")));
        novaInfo.setConteudo(novoConteudo);
        novaInfo.setDataCriacao(new Date());
        ServicoForumImpl serv = new ServicoForumImpl();
        serv.cadastra(novaInfo);
        infos.add(novaInfo);
        novoConteudo = null;
        }else{
            FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_WARN,
                                        "Conteúdo vazio", "Verifique se o campo conteúdo foi preenchido"));

    
        }
    }
    
    public void onRowEdit(RowEditEvent event) {
		Forum edt = ((Forum) event.getObject());
		if(edt.getAutor().getId() == 
                        ((Usuario)SessionContext.getInstance().getAttribute("usuarioLogadoS")).
                                getId()){
                    edt.setDataCriacao(new Date());
                    ServicoForumImpl serv = new ServicoForumImpl();
                    serv.edita(edt);
                     FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_INFO,
                                        "Conteúdo editado", "Sua mensagem foi editada com sucesso!"));
                }else{
                     FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_WARN,
                                        "Impossível editar", "Você não pode editar mensagens de outros autores!"));
                }		
		
	}
    
    public void removeInfo(Forum forum){
        if(forum.getAutor().getId() == 
                        ((Usuario)SessionContext.getInstance().getAttribute("usuarioLogadoS")).
                                getId()){
                    ServicoForumImpl serv = new ServicoForumImpl();
                    serv.remove(forum);
                    infos.remove(forum);
                     FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_INFO,
                                        "Conteúdo removido", "Sua mensagem foi removida com sucesso!"));
                }else{
                     FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_WARN,
                                        "Impossível remover", "Você não pode remover mensagens de outros autores!"));
                }	
        
        
    }
}
