/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package web.beans;

import java.io.Serializable;
import java.util.List;
import javax.annotation.PostConstruct;
import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ViewScoped;
import javax.faces.context.FacesContext;
import modelos.Projeto;
import modelos.Usuario;
import servicoimpl.ServicoProjetoImpl;
import servicoimpl.ServicoUsuarioImpl;

/**
 *
 * @author DanielDruszcz
 */
@ViewScoped
@ManagedBean
(name = "listau")
public class BeanListaUsuarios implements Serializable{
     private List<Usuario> usuarios;
     private Usuario selectedUser;
     @PostConstruct
    public void init() {
        try{
        selectedUser = new Usuario();
        ServicoUsuarioImpl serv = new ServicoUsuarioImpl();
        usuarios = serv.listaUsuariosValidos();
        }catch (Exception e){
            e.printStackTrace();
        }
    }

    public List<Usuario> getUsuarios() {
        return usuarios;
    }

    public void setUsuarios(List<Usuario> usuarios) {
        this.usuarios = usuarios;
    }
    
    public void ativa(Usuario usuario){
            ServicoUsuarioImpl servUser = new ServicoUsuarioImpl();
            usuarios.remove(usuario);
            Usuario novo = servUser.ativaInat(usuario);
            novo.setMostraU(true);
            usuarios.add(novo);
            FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_INFO, 
                                        "Usuário ativado!", "Este usuário foi ativado com sucesso!"));
    }
    
    public void desativa(Usuario usuario){
        ServicoProjetoImpl serv = new ServicoProjetoImpl();
        List<Projeto> projs = serv.consultaMod(usuario);
        if(projs != null && projs.size() > 0){
            String projsMostra = new String();
            for(int i = 0; i < projs.size(); i++){
                projsMostra = projs.get(i).getNome() + "  ";
            }
            FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_FATAL, 
                                        "Você não pode desativar este usuário!", "Este usuário é moderador de: " + projsMostra+
                                                ". Desative os projetos ou troque o moderador!"));
        }else{
            ServicoUsuarioImpl servUser = new ServicoUsuarioImpl();
            usuarios.remove(usuario);
            Usuario novo = servUser.desativa(usuario);
            novo.setMostraU(false);
            usuarios.add(novo);
            FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_INFO, 
                                        "Usuário desativado!", "Este usuário foi desativado com sucesso!"));
        }
        
    }

    public Usuario getSelectedUser() {
        return selectedUser;
    }

    public void setSelectedUser(Usuario selectedUser) {
        this.selectedUser = selectedUser;
    }
    
    
    
}
