/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package web.beans;


import java.io.IOException;
import java.io.Serializable;
import java.util.logging.Level;
import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ManagedProperty;
import javax.faces.bean.SessionScoped;
import javax.faces.bean.ViewScoped;
import javax.faces.context.FacesContext;
import modelos.Usuario;
import web.utilidades.JSFUtil;
import web.utilidades.SessionContext;
import web.utilidades.UsuarioBO;
import web.utilidades.UsuarioLogado;

/**
 *
 * @author DanielDruszcz
 */
@ViewScoped
@ManagedBean(name = "login")
public class BeanLogin implements Serializable{
    
    private static final long serialVersionUID = 1L;
    
    private String login;
    private String senha;
    private boolean logout = false;
    private UsuarioBO userBO = new UsuarioBO();
    
    public Usuario getUser() {
        return (Usuario) SessionContext.getInstance().getUsuarioLogado();
    }

    public String doLogin() {
        try {
            Usuario user =(Usuario) userBO.isUsuarioReadyToLogin(this.login, this.senha);
            if (user == null) {
                FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_FATAL, 
                                        "Login falhou!", "Verifique se os valores estão corretos!"));
                FacesContext.getCurrentInstance().validationFailed();
                return "";
            }
            if(user.getTipoUsuario().getId() == 0){
                FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_WARN, 
                                        "Aguarde", "O ADM ainda não validou seu login!"));
                FacesContext.getCurrentInstance().validationFailed();
                return "";
            }
            if(!user.isAtivo()){
                FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_WARN, 
                                        "Você foi desativado do sistema", "Entre em contato com a administração para mais informações!"));
                FacesContext.getCurrentInstance().validationFailed();
                return "";
            }
            SessionContext.getInstance().setAttribute("usuarioLogadoS", user);
            return "/pgs/home.xhtml?faces-redirect=true";
        } catch (Exception e) {
           // addErrorMessage(e.getMessage());
            FacesContext.getCurrentInstance().validationFailed();
            e.printStackTrace();
            return "";
        }
    }

    public void doLogout() {
        SessionContext.getInstance().encerrarSessao();
        logout = true;
        JSFUtil.addInfoMessage("Logout realizado com sucesso!");
        try {
            FacesContext.getCurrentInstance().getExternalContext()
                    .redirect("login.xhtml");
        } catch (IOException ex) {
            java.util.logging.Logger.getLogger(BeanLogin.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

//    public void solicitarNovaSenha() {
//        try {
//            getUserBO().gerarNovaSenha(login, email);
//            addInfoMessage("Nova Senha enviada para o email " + email);
//        } catch (Exception e) {
//            addErrorMessage(e.getMessage());
//            FacesContext.getCurrentInstance().validationFailed();
//        }
//    }

    public UsuarioBO getUserBO() {
        return userBO;
    }
    
    public String getLogin() {
        return login;
    }

    public void setLogin(String nome) {
        this.login = nome;
    }

    public String getSenha() {
        return senha;
    }

    public void setSenha(String senha) {
        this.senha = senha;
    }

    public boolean isLogout() {
        return logout;
    }

    public void setLogout(boolean logout) {
        this.logout = logout;
    }
    
    
}
