/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package web.beans;

import java.io.FileOutputStream;
import java.io.IOException;
import java.io.Serializable;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.UUID;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.annotation.PostConstruct;
import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ViewScoped;
import javax.faces.context.FacesContext;
import modelos.Exame;
import modelos.Forum;
import modelos.ForumProjeto;
import modelos.ImagemOriginal;
import modelos.Paciente;
import modelos.Projeto;
import modelos.Usuario;
import org.primefaces.event.FileUploadEvent;
import org.primefaces.event.RowEditEvent;
import org.primefaces.event.SelectEvent;
import org.primefaces.model.DualListModel;
import org.primefaces.model.UploadedFile;
import org.primefaces.model.chart.Axis;
import org.primefaces.model.chart.AxisType;
import org.primefaces.model.chart.BarChartModel;
import org.primefaces.model.chart.ChartSeries;
import servico.ServicoImagemOriginal;
import servicoimpl.ServicoConversorImpl;
import servicoimpl.ServicoExameImpl;
import servicoimpl.ServicoForumImpl;
import servicoimpl.ServicoImagemOriginalImpl;
import servicoimpl.ServicoPacienteImpl;
import servicoimpl.ServicoProjetoImpl;
import servicoimpl.ServicoUsuarioImpl;
import web.utilidades.SessionContext;

/**
 *
 * @author DanielDruszcz
 */
@ViewScoped
@ManagedBean(name = "gproj")
public class BeanProjeto implements Serializable {

    private Projeto projeto;
    private boolean mostramod = false;
    private DualListModel<Usuario> users;
    private Usuario usuarioSelecionado;
    private ArrayList<ForumProjeto> infos;
    private List<Exame> exames;
    private ForumProjeto novaInfo = null;
    private String novoConteudo;
    private BarChartModel barModel;
    private List<Usuario> usuarios;
    private boolean mostraAp = false;
    private boolean mostraFo = false;
    private boolean mostraUp = false;
    private boolean mostraIo = false;
    private boolean mostraIs = false;
    private boolean mostraEs = false;
    private boolean mostraUs = false;
    private List<UploadedFile> imgs;
    private List<Projeto> projs = null;
    private String nomeExame = null;
    private boolean verificaC = false;
    private boolean tipoExame = false;
    private boolean instituicaoNome = false;
    private String modalidade = null;
    private String instituicao = null;
    private Paciente p = null;
    private Exame e = null;
    private List<String> referencia = null;
    private int numUsers = 0;
    private int numExames = 0;
    private int tipoFiltro = 0;
    private boolean mostraGraf = true;

    @PostConstruct
    public void init() {
        if (FacesContext.getCurrentInstance().getExternalContext().getFlash()
                .get("proj") != null) {
            projeto = new Projeto();
            projeto = (((Projeto) FacesContext.getCurrentInstance()
                    .getExternalContext().getFlash().get("proj")));
            mostramod = verificaModerador();
            if (mostramod == true) {
                mostraAp = true;
                usuarioSelecionado = new Usuario();
                ServicoProjetoImpl serv = new ServicoProjetoImpl();
                List<Usuario> userswt = serv.listaSolicitacoes(projeto);
                List<Usuario> userssl = new ArrayList<Usuario>();
                users = new DualListModel<Usuario>(userswt, userssl);
            } else {
                mostraFo = true;
            }

            ServicoForumImpl serv = new ServicoForumImpl();
            infos = new ArrayList<ForumProjeto>();
            infos = serv.lista(projeto);
        } else {
            try {
                FacesContext.getCurrentInstance().getExternalContext()
                        .redirect("meusprojetos.xhtml");
            } catch (IOException ex) {
                //   Logger.getLogger(BeanProjeto.getN).log(Level.SEVERE, null, ex);
            }
        }

    }

    public void onRowEdit(RowEditEvent event) {
        ForumProjeto edt = ((ForumProjeto) event.getObject());
        if (edt.getAutor().getId()
                == ((Usuario) SessionContext.getInstance().getAttribute("usuarioLogadoS")).
                getId()) {
            edt.setDataCriacao(new Date());
            ServicoForumImpl serv = new ServicoForumImpl();
            serv.edita(edt);
            FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_INFO,
                    "Conteúdo editado", "Sua mensagem foi editada com sucesso!"));
        } else {
            FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_WARN,
                    "Impossível editar", "Você não pode editar mensagens de outros autores!"));
        }

    }

    public void removeInfo(ForumProjeto forum) {
        if (forum.getAutor().getId()
                == ((Usuario) SessionContext.getInstance().getAttribute("usuarioLogadoS")).
                getId()) {
            ServicoForumImpl serv = new ServicoForumImpl();
            serv.remove(forum);
            infos.remove(forum);
            FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_INFO,
                    "Conteúdo removido", "Sua mensagem foi removida com sucesso!"));
        } else {
            FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_WARN,
                    "Impossível remover", "Você não pode remover mensagens de outros autores!"));
        }

    }

    public BarChartModel getBarModel() {
        createBarModel();
        return barModel;
    }

    public void setBarModel(BarChartModel barModel) {
        this.barModel = barModel;
    }

    public Projeto getProjeto() {
        return projeto;
    }

    public void setProjeto(Projeto projeto) {
        this.projeto = projeto;
    }

    public boolean isMostramod() {
        return mostramod;
    }

    public void setMostramod(boolean mostramod) {
        this.mostramod = mostramod;
    }

    public void mostraApRp() {

    }

    public boolean isMostraAp() {
        return mostraAp;
    }

    public void setMostraAp(boolean mostraAp) {
        this.mostraAp = mostraAp;
    }

    public boolean isMostraFo() {
        return mostraFo;
    }

    public void setMostraFo(boolean mostraFo) {
        this.mostraFo = mostraFo;
    }

    public boolean isMostraUp() {
        return mostraUp;
    }

    public void setMostraUp(boolean mostraUp) {
        this.mostraUp = mostraUp;
    }

    public List<Usuario> getUsuarios() {
        return usuarios;
    }

    public void setUsuarios(List<Usuario> usuarios) {
        this.usuarios = usuarios;
    }

    public DualListModel<Usuario> getUsers() {
        return users;
    }

    public void setUsers(DualListModel<Usuario> users) {
        this.users = users;
    }

    public Usuario getUsuarioSelecionado() {
        return usuarioSelecionado;
    }

    public void setUsuarioSelecionado(Usuario usuarioSelecionado) {
        this.usuarioSelecionado = usuarioSelecionado;
    }

    public ArrayList<ForumProjeto> getInfos() {
        return infos;
    }

    public void setInfos(ArrayList<ForumProjeto> infos) {
        this.infos = infos;
    }

    public ForumProjeto getNovaInfo() {
        return novaInfo;
    }

    public void setNovaInfo(ForumProjeto novaInfo) {
        this.novaInfo = novaInfo;
    }

    public String getNovoConteudo() {
        return novoConteudo;
    }

    public void setNovoConteudo(String novoConteudo) {
        this.novoConteudo = novoConteudo;
    }

    public boolean isMostraIo() {
        return mostraIo;
    }

    public void setMostraIo(boolean mostraIo) {
        this.mostraIo = mostraIo;
    }

    public boolean isMostraIs() {
        return mostraIs;
    }

    public void setMostraIs(boolean mostraIs) {
        this.mostraIs = mostraIs;
    }

    public boolean isMostraEs() {
        return mostraEs;
    }

    public void setMostraEs(boolean mostraEs) {
        this.mostraEs = mostraEs;
    }

    public boolean isMostraUs() {
        return mostraUs;
    }

    public void setMostraUs(boolean mostraUs) {
        this.mostraUs = mostraUs;
    }

    public List<Exame> getExames() {
        return exames;
    }

    public void setExames(List<Exame> exames) {
        this.exames = exames;
    }

    private BarChartModel initBarModel() {
        BarChartModel model = new BarChartModel();
        ChartSeries filtro = new ChartSeries();
        Map<String, Integer> nfiltro = new HashMap<String, Integer>();
        ServicoExameImpl serv = new ServicoExameImpl();
        List<Exame> exames = serv.listaExamesProjeto(projeto);
        String maiores[] = null;
        switch (tipoFiltro) {
            case 1: {
                for (int i = 0; i < exames.size(); i++) {
                    if (exames.get(i).getModalidade() != null) {
                        if (nfiltro.get(exames.get(i).getModalidade()) == null) {
                            nfiltro.put(exames.get(i).getModalidade(), 0);
                        }
                        int x = nfiltro.get(exames.get(i).getModalidade());
                        nfiltro.put(exames.get(i).getModalidade(), x + 1);
                    }
                }
                nfiltro.put("chavezero", 0);
                Set<String> chaves = nfiltro.keySet();
                for (int i = 0; i < 5; i++) {
                    if (maiores == null) {
                        int j;
                        maiores = new String[5];
                        for (j = 0; j < 5; j++) {
                            maiores[j] = "chavezero";
                        }
                    }
                    for (String chave : chaves) {
                        if (nfiltro.get(chave) >= nfiltro.get(maiores[i])) {
                            int j = 0;
                            int t = 0;
                            for (j = 0; j < 5; j++) {
                                if (chave.equals(maiores[j])) {
                                    t = 1;
                                }
                            }
                            if (t != 1) {
                                maiores[i] = chave;
                            }
                        }

                    }
                }
                for (int i = 0; i < 5; i++) {
                    if (!maiores[i].equals("chavezero")) {
                        filtro.set((i + 1) + " - " + maiores[i].toUpperCase(),
                                nfiltro.get(maiores[i]));
                    }
                }
                break;
            }
            case 2: {
                   for (int i = 0; i < exames.size(); i++) {
                    if (exames.get(i).getModalidade() != null) {
                        if (nfiltro.get(exames.get(i).getLocal()) == null) {
                            nfiltro.put(exames.get(i).getLocal(), 0);
                        }
                        int x = nfiltro.get(exames.get(i).getLocal());
                        nfiltro.put(exames.get(i).getLocal(), x + 1);
                    }
                }
                nfiltro.put("chavezero", 0);
                Set<String> chaves = nfiltro.keySet();
                for (int i = 0; i < 5; i++) {
                    if (maiores == null) {
                        int j;
                        maiores = new String[5];
                        for (j = 0; j < 5; j++) {
                            maiores[j] = "chavezero";
                        }
                    }
                    for (String chave : chaves) {
                        if (nfiltro.get(chave) >= nfiltro.get(maiores[i])) {
                            int j = 0;
                            int t = 0;
                            for (j = 0; j < 5; j++) {
                                if (chave.equals(maiores[j])) {
                                    t = 1;
                                }
                            }
                            if (t != 1) {
                                maiores[i] = chave;
                            }
                        }

                    }
                }
                for (int i = 0; i < 5; i++) {
                    if (!maiores[i].equals("chavezero")) {
                        filtro.set((i + 1) + " - " + maiores[i].toUpperCase(),
                                nfiltro.get(maiores[i]));
                    }
                }
                break;
            }
            default: {
                filtro.set(" ", 0);
            }
        }
        filtro.setLabel("Valores");
        model.addSeries(filtro);
        return model;
    }

    private void createBarModel() {
        barModel = initBarModel();
        Axis xAxis = barModel.getAxis(AxisType.X);
        switch (tipoFiltro) {
            case 1:
                barModel.setTitle("Modalidade do exame");
                xAxis.setLabel("Modalidades");
                break;
            case 2:
                barModel.setTitle("Instituicao do exame");
                xAxis.setLabel("Instituições");
                break;
        }

        barModel.setLegendPosition("ne");
        Axis yAxis = barModel.getAxis(AxisType.Y);
    }

    public void geraGraf() {
        createBarModel();
        mostraGraf = false;
    }

    private boolean verificaModerador() {
        if (projeto.getModerador().getId()
                == ((Usuario) SessionContext.getInstance().getAttribute("usuarioLogadoS")).getId()) {
            return true;
        } else {
            return false;
        }
    }

    private void isFalse() {
        mostraAp = false;
        mostraFo = false;
        mostraUp = false;
        mostraIo = false;
        mostraIs = false;
        mostraEs = false;
        mostraUs = false;
    }

    public void mudaPAp() {
        isFalse();
        mostraAp = true;
    }

    public void mudaPFo() {
        isFalse();
        mostraFo = true;
    }

    public void mudaPUp() {
        isFalse();
        mostraUp = true;
    }

    public void mudaPEs() {
        ServicoProjetoImpl serv = new ServicoProjetoImpl();
        numUsers = serv.contaUsers(projeto);
        numExames = serv.contaExames(projeto);
        isFalse();
        mostraEs = true;
    }

    public void mudaPUs() {
        ServicoProjetoImpl serv = new ServicoProjetoImpl();
        usuarios = serv.listaUsuariosProjeto(projeto);
        isFalse();
        mostraUs = true;
    }

    public void mudaPIo() {
        ServicoExameImpl serv = new ServicoExameImpl();
        exames = serv.listaExamesProjeto(projeto);
        isFalse();
        mostraIo = true;
    }

    public void aprovar() {
        try {
            ServicoProjetoImpl serv = new ServicoProjetoImpl();
            for (int i = 0; i < users.getTarget().size(); i++) {
                serv.ativaVinculo(users.getTarget().get(i), projeto);
            }
            FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_INFO,
                    "Usuários ativados!", "Os usuários selecionados foram ativados com sucesso!"));
            users.getTarget().clear();
        } catch (Exception e) {
            FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_FATAL,
                    "Ocorreu uma falha grave!", "Falha ao aprovar, contate o analista responsável!"));
            e.printStackTrace();;
        }
    }

    public void reprovar() {
        try {
            ServicoProjetoImpl serv = new ServicoProjetoImpl();
            for (int i = 0; i < users.getTarget().size(); i++) {
                serv.removeVinculo(users.getTarget().get(i), projeto);
            }
            FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_INFO,
                    "Usuários reprovados!", "Os usuários selecionados foram removidos com sucesso!"));
            users.getTarget().clear();
        } catch (Exception e) {
            FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_FATAL,
                    "Ocorreu uma falha grave!", "Falha ao reprovar, contate o analista responsável!"));
            e.printStackTrace();;
        }
    }

    public void gravarInfo() {
        if (novoConteudo != null && !novoConteudo.isEmpty()) {
            novaInfo = new ForumProjeto();
            novaInfo.setAutor(((Usuario) SessionContext.getInstance().getAttribute("usuarioLogadoS")));
            novaInfo.setIdprojeto(projeto.getId());
            novaInfo.setConteudo(novoConteudo);
            novaInfo.setDataCriacao(new Date());
            ServicoForumImpl serv = new ServicoForumImpl();
            serv.cadastra(novaInfo);
            infos.add(novaInfo);
            FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_INFO,
                    "Conteúdo adicionado", "Conteúdo adicionado com sucesso ao projeto!"));
            novoConteudo = null;
        } else {
            FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_WARN,
                    "Conteúdo vazio", "Verifique se o campo conteúdo foi preenchido"));

        }
    }

    public void onSelect(SelectEvent event) {
        usuarioSelecionado = (((Usuario) event.getObject()));
    }

    public void abreExame(Exame exame) {
        FacesContext.getCurrentInstance().getExternalContext().getFlash().put("exam", exame);
        try {
            FacesContext.getCurrentInstance().getExternalContext()
                    .redirect("galeria.xhtml");
        } catch (IOException ex) {
            //   Logger.getLogger(BeanProjeto.getN).log(Level.SEVERE, null, ex);
        }

    }

    public void removerVinculo(Usuario usuario) {
        try {
            ServicoProjetoImpl serv = new ServicoProjetoImpl();
            serv.removeVinculo(usuario, projeto);
            usuarios.remove(usuario);
            FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_INFO,
                    "Usuário removido", "Usuário selecionado removido com sucesso do projeto!"));
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void removerVinculo() {
        try {
            ServicoProjetoImpl serv = new ServicoProjetoImpl();
            serv.removeVinculo(((Usuario) SessionContext.getInstance().getAttribute("usuarioLogadoS")), projeto);
            FacesContext.getCurrentInstance().getExternalContext()
                    .redirect("galeria.xhtml");
            FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_INFO,
                    "Você saiu do projeto", "Seu vinculo com o projeto selecionado foi removido!"));

        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void carregarImgs(FileUploadEvent event) {
        if (event != null) {
            if (imgs != null) {
                if (event.getFile().getContents() != null) {
                    if (event.getFile().getFileName().contains(".")) {
                        if (!event.getFile().getFileName().contains(".dcm")) {
                            FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_FATAL,
                                    "Não será possivel registrar " + event.getFile().getFileName() + "!", "Verifique o tipo do arquivo. "
                            ));
                        } else {
                            imgs.add(event.getFile());
                        }
                    } else {
                        imgs.add(event.getFile());
                    }
                }

            } else {
                imgs = new ArrayList<>();
                if (event.getFile().getContents() != null) {
                    if (event.getFile().getFileName().contains(".")) {
                        if (!event.getFile().getFileName().contains(".dcm")) {
                            FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_FATAL,
                                    "Não será possivel registrar " + event.getFile().getFileName() + "!", "Verifique o tipo do arquivo. "
                            ));
                        } else {
                            imgs.add(event.getFile());
                        }
                    } else {
                        imgs.add(event.getFile());
                    }
                }
            }
        }
    }
    //remover primeira e segunda tentativa
    //gravar tudo de uma vez e depois dar update nos valores

    public void registrarExame() {
        String imagemURL = "C:\\XMedCon\\bin\\";
        ServicoConversorImpl serv = null;
        ServicoExameImpl servE = null;
        ServicoPacienteImpl servP = null;
        ServicoImagemOriginal servI = null;
        referencia = new ArrayList<>();
        if (imgs != null && !imgs.isEmpty()) {
            UUID nomeID1 = UUID.randomUUID();
            String imagemURL1 = imagemURL + nomeID1 + "]" + imgs.get(0).getFileName();
            try (final FileOutputStream fos = new FileOutputStream(imagemURL1)) {
                fos.write(imgs.get(0).getContents());
                fos.flush();
                fos.close();
            } catch (Exception ex) {
                FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_FATAL,
                        "Erro ao gravar arquivo!", "Tente novamente ou contate o analista "
                        + "responsável!"));
                ex.printStackTrace();
            }
            serv = new ServicoConversorImpl();
            Map<String, String> resTxt = null;
            resTxt = serv.extraiArquivo(nomeID1 + "]" + imgs.get(0).getFileName());
            if (resTxt == null) {
                FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_FATAL,
                        "Falhou ao obter arquivo!", "Tente novamente ou contate o analista "
                        + "responsável!"));
                return;
            }
            if (resTxt.containsKey("slice")
                    && Integer.parseInt(resTxt.get("slice").replace(" ", "")) > 1) {
                serv = new ServicoConversorImpl();
                serv.geraSlice(nomeID1 + "]" + imgs.get(0).getFileName());
                for (int i = 1; i < Integer.parseInt(resTxt.get("slice").replace(" ", "")); i++) {
                    String format = null;
                    String serie = format.format("%04d", i);
                    serv.anon("m000-s" + serie + "-" + nomeID1 + "]" + imgs.get(0).getFileName());
                    boolean testaConversor = serv.executaConvertePNG("m000-s" + serie + "-" + nomeID1 + "]" + imgs.get(0).getFileName());
                    if (testaConversor != true) {
                        FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_FATAL,
                                imgs.get(0).getFileName() + " Falhou!", "Verifique o tipo do arquivo, tente novamente ou contate o analista "
                                + "responsável!"));
                    } else {
                        referencia.add("m000-s" + serie + "-" + nomeID1 + "]" + imgs.get(0).getFileName());
                    }
                }

            } else {
                serv.anon(nomeID1 + "]" + imgs.get(0).getFileName());
                boolean testaConversor = serv.executaConvertePNG(nomeID1 + "]" + imgs.get(0).getFileName());
                if (testaConversor != true) {
                    FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_FATAL,
                            imgs.get(0).getFileName() + " Falhou!", "Verifique o tipo do arquivo, tente novamente ou contate o analista "
                            + "responsável!"));
                } else {
                    referencia.add(nomeID1 + "]" + imgs.get(0).getFileName());
                }
                for (int i = 1; i < imgs.size(); i++) {
                    UUID nomeID = UUID.randomUUID();
                    String imagemURL2 = imagemURL + nomeID + "]" + imgs.get(i).getFileName();
                    try (final FileOutputStream fos = new FileOutputStream(imagemURL2)) {
                        fos.write(imgs.get(i).getContents());
                        fos.flush();
                        fos.close();
                    } catch (Exception ex) {
                        FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_FATAL,
                                "Erro ao gravar arquivo!", "Tente novamente ou contate o analista "
                                + "responsável!"));
                    }
                    serv.anon(nomeID + "]" + imgs.get(i).getFileName());
                    testaConversor = serv.executaConvertePNG(nomeID + "]" + imgs.get(i).getFileName());
                    if (testaConversor != true) {
                        FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_FATAL,
                                imgs.get(i).getFileName() + " Falhou!", "Verifique o tipo do arquivo, tente novamente ou contate o analista "
                                + "responsável!"));
                    } else {
                        referencia.add(nomeID + "]" + imgs.get(i).getFileName());
                    }
                }
                imgs = null;
            }
            p = new Paciente();
            if (resTxt.containsKey("datapaciente")) {
                p.setDataNasc(montaData(resTxt.get("datapaciente")));
            } else {
                p.setDataNasc(null);
            }
            if (resTxt.containsKey("sexopaciente")) {
                p.setSexo(resTxt.get("sexopaciente"));
            } else {
                p.setSexo("Não informado");
            }
            if (resTxt.containsKey("idadepaciente")) {
                p.setIdade(resTxt.get("idadepaciente").replace("Y", ""));
            } else {
                p.setIdade("Não informado");
            }
            servP = new ServicoPacienteImpl();
            p = servP.cadastra(p);
            e = new Exame();
            if (tipoExame) {
                if (instituicao != null) {
                    e.setLocal(instituicao);
                } else {
                    e.setLocal("Não informado");
                }
                if (modalidade != null) {
                    e.setModalidade(modalidade);
                } else {
                    e.setModalidade("Não informado");
                }
            } else {
                if (resTxt.containsKey("local")) {
                    e.setLocal(resTxt.get("local"));
                } else {
                    e.setLocal("Não informado");
                }
                if (resTxt.containsKey("modalidade")) {
                    e.setModalidade(resTxt.get("modalidade"));
                } else {
                    e.setModalidade("Não informado");
                }
            }
            e.setAnon(tipoExame);
            e.setDataDeEnvio(new Date());
            e.setUsuarioUpload(((Usuario) SessionContext.getInstance().getAttribute("usuarioLogadoS")));
            e.setQuantidade(referencia.size());
            e.setNome(nomeExame);
            e.setProjeto(projeto);
            if (resTxt.containsKey("dataexame")) {
                e.setDataDoExame(montaData(resTxt.get("dataexame")));
            } else {
                e.setDataDoExame(null);
            }
            e.setPaciente(p);
            servE = new ServicoExameImpl();
            e = servE.cadastra(e);
            List<ImagemOriginal> imagens = new ArrayList<>();
            for (String img : referencia) {
                String nome[] = img.split("\\]");
                ImagemOriginal imagem = new ImagemOriginal();
                imagem.setCorte(10);
                imagem.setExame(e);
                if (img.contains(".dcm")) {
                    imagem.setLocalImagem("m000-" + img);
                    img = img.replace(".dcm", "");
                } else {
                    imagem.setLocalImagem("m000-" + img + ".dcm");
                }
                imagem.setLocalPng(img);
                if (nome[0].contains("-s") && nome[0].contains("m0")) {
                    String index[] = nome[0].split("-");
                    imagem.setNome(index[1] + "-" + nome[1]);
                } else {
                    imagem.setNome(nome[1]);
                }
                imagens.add(imagem);
            }
            servI = new ServicoImagemOriginalImpl();
            servI.cadastra(imagens);
            FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_INFO,
                    "Exame cadastrado.", " Obrigado!"));
        } else {
            FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_FATAL,
                    "Carregue suas imagens!", "Para registrar seu exame, você precisa antes "
                    + "carregar suas imagens."));
        }
    }

    private Date montaData(String data) {
        StringBuilder stringBuilder = new StringBuilder();//data);
        for (int c = 0; c < data.length(); c++) {
            if (c == 4 || c == 6) {
                stringBuilder.append(data.charAt(c));
                stringBuilder.append("-");
            } else {
                stringBuilder.append(data.charAt(c));
            }
        }
        String dataNova = stringBuilder.toString().replace(" ", "");
        Date date = null;
        DateFormat formatter = new SimpleDateFormat("yyyy-MM-dd");
        try {
            date = (java.util.Date) formatter.parse(dataNova);
        } catch (ParseException ex) {
            Logger.getLogger(BeanUpload.class.getName()).log(Level.SEVERE, null, ex);
        }
        return date;
    }

    public List<UploadedFile> getImgs() {
        return imgs;
    }

    public void setImgs(List<UploadedFile> imgs) {
        this.imgs = imgs;
    }

    public List<Projeto> getProjs() {
        return projs;
    }

    public void setProjs(List<Projeto> projs) {
        this.projs = projs;
    }

    public String getNomeExame() {
        return nomeExame;
    }

    public void setNomeExame(String nomeExame) {
        this.nomeExame = nomeExame;
    }

    public boolean isVerificaC() {
        return verificaC;
    }

    public void setVerificaC(boolean verificaC) {
        this.verificaC = verificaC;
    }

    public boolean isTipoExame() {
        return tipoExame;
    }

    public void setTipoExame(boolean tipoExame) {
        this.tipoExame = tipoExame;
    }

    public boolean isInstituicaoNome() {
        return instituicaoNome;
    }

    public void setInstituicaoNome(boolean instituicaoNome) {
        this.instituicaoNome = instituicaoNome;
    }

    public String getModalidade() {
        return modalidade;
    }

    public void setModalidade(String modalidade) {
        this.modalidade = modalidade;
    }

    public String getInstituicao() {
        return instituicao;
    }

    public void setInstituicao(String instituicao) {
        this.instituicao = instituicao;
    }

    public Paciente getP() {
        return p;
    }

    public void setP(Paciente p) {
        this.p = p;
    }

    public Exame getE() {
        return e;
    }

    public void setE(Exame e) {
        this.e = e;
    }

    public List<String> getReferencia() {
        return referencia;
    }

    public void setReferencia(List<String> referencia) {
        this.referencia = referencia;
    }

    public int getNumUsers() {
        return numUsers;
    }

    public void setNumUsers(int numUsers) {
        this.numUsers = numUsers;
    }

    public int getNumExames() {
        return numExames;
    }

    public void setNumExames(int numExames) {
        this.numExames = numExames;
    }

    public int getTipoFiltro() {
        return tipoFiltro;
    }

    public void setTipoFiltro(int tipoFiltro) {
        this.tipoFiltro = tipoFiltro;
    }

    public boolean isMostraGraf() {
        return mostraGraf;
    }

    public void setMostraGraf(boolean mostraGraf) {
        this.mostraGraf = mostraGraf;
    }

}
