package web.beans;

import java.beans.Transient;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.Serializable;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.UUID;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.annotation.PostConstruct;
import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ViewScoped;
import javax.faces.context.FacesContext;
import modelos.Exame;
import modelos.ImagemOriginal;
import modelos.Paciente;
import modelos.Projeto;
import modelos.Usuario;
import org.primefaces.event.FileUploadEvent;
import org.primefaces.model.UploadedFile;
import servico.ServicoImagemOriginal;
import servicoimpl.ServicoConversorImpl;
import servicoimpl.ServicoExameImpl;
import servicoimpl.ServicoImagemOriginalImpl;
import servicoimpl.ServicoPacienteImpl;
import servicoimpl.ServicoProjetoImpl;
import web.utilidades.SessionContext;

@ViewScoped
@ManagedBean
public class BeanUpload implements Serializable {

    private List<UploadedFile> imgs;
    private List<Projeto> projs = null;
    private Projeto projetoSelecionado = null;
    private String nomeExame = null;
    private boolean verificaC = false;
    private boolean tipoExame = false;
    private boolean instituicaoNome = false;
    private String modalidade = null;
    private String instituicao = null;
    private Paciente p = null;
    private Exame e = null;
    private List<String> referencia = null;

    @PostConstruct
    public void init() {
        projs = new ArrayList<>();
        ServicoProjetoImpl proj = new ServicoProjetoImpl();
        List<Projeto> projs2 = proj.listaProjetosUsuario(((Usuario) SessionContext.getInstance().getAttribute("usuarioLogadoS")));
        for (int i = 0; i < projs2.size(); i++) {
            if (projs2.get(i).isMostra()) {
                projs.add(projs2.get(i));
            }
        }
    }

    public void carregarImgs(FileUploadEvent event) {
        if (event != null) {
            if (imgs != null) {
                if (event.getFile().getContents() != null) {
                    if (event.getFile().getFileName().contains(".")) {
                        if (!event.getFile().getFileName().contains(".dcm")) {
                            FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_FATAL,
                                    "Não será possivel registrar "+event.getFile().getFileName()+"!"
                                    , "Verifique o tipo do arquivo. "
                                   ));
                        } else {
                            imgs.add(event.getFile());
                        }
                    } else {
                        imgs.add(event.getFile());
                    }
                }

            } else {
                imgs = new ArrayList<>();
                if (event.getFile().getContents() != null) {
                    if (event.getFile().getFileName().contains(".")) {
                        if (!event.getFile().getFileName().contains(".dcm")) {
                           FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_FATAL,
                                    "Não será possivel registrar "+event.getFile().getFileName()+"!"
                                    , "Verifique o tipo do arquivo. "
                                   ));
                        } else {
                            imgs.add(event.getFile());
                        }
                    } else {
                        imgs.add(event.getFile());
                    }
                }
            }
        }
    }
    //remover primeira e segunda tentativa
    //gravar tudo de uma vez e depois dar update nos valores

    public void registrarExame() {
        String imagemURL = "C:\\XMedCon\\bin\\";
        ServicoConversorImpl serv = null;
        ServicoExameImpl servE = null;
        ServicoPacienteImpl servP = null;
        ServicoImagemOriginal servI = null;
        referencia = new ArrayList<>();
        if (imgs != null && !imgs.isEmpty()) {
            UUID nomeID1 = UUID.randomUUID();
            String imagemURL1 = imagemURL + nomeID1 + "]" + imgs.get(0).getFileName();
            try (final FileOutputStream fos = new FileOutputStream(imagemURL1)) {
                fos.write(imgs.get(0).getContents());
                fos.flush();
                fos.close();
            } catch (Exception ex) {
                FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_FATAL,
                        "Erro ao gravar arquivo!", "Tente novamente ou contate o analista "
                        + "responsável!"));
                ex.printStackTrace();
            }
            serv = new ServicoConversorImpl();
            Map<String, String> resTxt = null;
            resTxt = serv.extraiArquivo(nomeID1 + "]" + imgs.get(0).getFileName());
            if (resTxt == null) {
                FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_FATAL,
                        "Falhou ao obter arquivo!", "Tente novamente ou contate o analista "
                        + "responsável!"));
                return;
            }
            if (resTxt.containsKey("slice") && 
                    Integer.parseInt(resTxt.get("slice").replace(" ", ""))> 1) {
                serv = new ServicoConversorImpl();
                serv.geraSlice(nomeID1 + "]" + imgs.get(0).getFileName());
                for (int i = 1; i < Integer.parseInt(resTxt.get("slice").replace(" ", "")); i++) {
                    String format = null;
                    String serie = format.format("%04d", i);
                    serv.anon("m000-s" + serie + "-" + nomeID1 + "]" + imgs.get(0).getFileName());
                    boolean testaConversor = serv.executaConvertePNG("m000-s" + serie + "-" + nomeID1 + "]" + imgs.get(0).getFileName());
                    if (testaConversor != true) {
                        FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_FATAL,
                                imgs.get(0).getFileName() + " Falhou!", "Verifique o tipo do arquivo, tente novamente ou contate o analista "
                                + "responsável!"));
                    } else {
                        referencia.add("m000-s" + serie + "-" + nomeID1 + "]" + imgs.get(0).getFileName());
                    }
                }

            } else {
                serv.anon(nomeID1 + "]" + imgs.get(0).getFileName());
                boolean testaConversor = serv.executaConvertePNG(nomeID1 + "]" + imgs.get(0).getFileName());
                if (testaConversor != true) {
                    FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_FATAL,
                            imgs.get(0).getFileName() + " Falhou!", "Verifique o tipo do arquivo, tente novamente ou contate o analista "
                            + "responsável!"));
                } else {
                    referencia.add(nomeID1 + "]" + imgs.get(0).getFileName());
                }
                for (int i = 1; i < imgs.size(); i++) {
                    UUID nomeID = UUID.randomUUID();
                    String imagemURL2 = imagemURL + nomeID + "]" + imgs.get(i).getFileName();
                    try (final FileOutputStream fos = new FileOutputStream(imagemURL2)) {
                        fos.write(imgs.get(i).getContents());
                        fos.flush();
                        fos.close();
                    } catch (Exception ex) {
                        FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_FATAL,
                                "Erro ao gravar arquivo!", "Tente novamente ou contate o analista "
                                + "responsável!"));
                    }
                    serv.anon(nomeID + "]" + imgs.get(i).getFileName());
                    testaConversor = serv.executaConvertePNG(nomeID + "]" + imgs.get(i).getFileName());
                    if (testaConversor != true) {
                        FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_FATAL,
                                imgs.get(i).getFileName() + " Falhou!", "Verifique o tipo do arquivo, tente novamente ou contate o analista "
                                + "responsável!"));
                    } else {
                        referencia.add(nomeID + "]" + imgs.get(i).getFileName());
                    }
                }
                imgs = null;
            }
            p = new Paciente();
            if (resTxt.containsKey("datapaciente")) {
                p.setDataNasc(montaData(resTxt.get("datapaciente")));
            } else {
                p.setDataNasc(null);
            }
            if (resTxt.containsKey("sexopaciente")) {
                p.setSexo(resTxt.get("sexopaciente"));
            } else {
                p.setSexo("Não informado");
            }
            if (resTxt.containsKey("idadepaciente")) {
                p.setIdade(resTxt.get("idadepaciente").replace("Y", ""));
            } else {
                p.setIdade("Não informado");
            }
            servP = new ServicoPacienteImpl();
            p = servP.cadastra(p);
            e = new Exame();
            if (tipoExame) {
                if (instituicao != null) {
                    e.setLocal(instituicao);
                } else {
                    e.setLocal("Não informado");
                }
                if (modalidade != null) {
                    e.setModalidade(modalidade);
                } else {
                    e.setModalidade("Não informado");
                }
            } else {
                if (resTxt.containsKey("local")) {
                    e.setLocal(resTxt.get("local"));
                } else {
                    e.setLocal("Não informado");
                }
                if (resTxt.containsKey("modalidade")) {
                    e.setModalidade(resTxt.get("modalidade"));
                } else {
                    e.setModalidade("Não informado");
                }
            }
            e.setAnon(tipoExame);
            e.setDataDeEnvio(new Date());
            e.setUsuarioUpload(((Usuario) SessionContext.getInstance().getAttribute("usuarioLogadoS")));
            e.setQuantidade(referencia.size());
            e.setNome(nomeExame);
            e.setProjeto(projetoSelecionado);
            if (resTxt.containsKey("dataexame")) {
                e.setDataDoExame(montaData(resTxt.get("dataexame")));
            } else {
                e.setDataDoExame(null);
            }
            e.setPaciente(p);
            servE = new ServicoExameImpl();
            e = servE.cadastra(e);
            List<ImagemOriginal> imagens = new ArrayList<>();
            for (String img : referencia) {
                String nome[] = img.split("\\]");
                ImagemOriginal imagem = new ImagemOriginal();
                imagem.setCorte(10);
                imagem.setExame(e);
                if (img.contains(".dcm")) {
                    imagem.setLocalImagem("m000-"+img);
                    img = img.replace(".dcm", "");
                }else{
                    imagem.setLocalImagem("m000-"+img+".dcm");
                }
                imagem.setLocalPng(img);
                if (nome[0].contains("-s") && nome[0].contains("m0")) {
                    String index[] = nome[0].split("-");
                    imagem.setNome(index[1] + "-" + nome[1]);
                } else {
                    imagem.setNome(nome[1]);
                }
                imagens.add(imagem);
            }
            servI = new ServicoImagemOriginalImpl();
            servI.cadastra(imagens);
            FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_INFO,
                    "Exame cadastrado.", " Obrigado!"));
        } else {
            FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_FATAL,
                    "Carregue suas imagens!", "Para registrar seu exame, você precisa antes "
                    + "carregar suas imagens."));
        }
    }

    private Date montaData(String data) {
        StringBuilder stringBuilder = new StringBuilder();//data);
        for (int c = 0; c < data.length(); c++) {
            if (c == 4 || c == 6) {
                stringBuilder.append(data.charAt(c));
                stringBuilder.append("-");
            } else {
                stringBuilder.append(data.charAt(c));
            }
        }
        String dataNova = stringBuilder.toString().replace(" ", "");
        Date date = null;
        DateFormat formatter = new SimpleDateFormat("yyyy-MM-dd");
        try {
            date = (java.util.Date) formatter.parse(dataNova);
        } catch (ParseException ex) {
            Logger.getLogger(BeanUpload.class.getName()).log(Level.SEVERE, null, ex);
        }
        return date;
    }

    @Transient
    public List<UploadedFile> getImgs() {
        return imgs;
    }

    public void setImgs(List<UploadedFile> imgs) {
        this.imgs = imgs;
    }

    public String getNomeExame() {
        return nomeExame;
    }

    public void setNomeExame(String nomeExame) {
        this.nomeExame = nomeExame;
    }

    public List<Projeto> getProjs() {
        return projs;
    }

    public void setProjs(List<Projeto> projs) {
        this.projs = projs;
    }

    public boolean isVerificaC() {
        return verificaC;
    }

    public void setVerificaC(boolean verificaC) {
        this.verificaC = verificaC;
    }

    public boolean isTipoExame() {
        return tipoExame;
    }

    public void setTipoExame(boolean tipoExame) {
        this.tipoExame = tipoExame;
    }

    public boolean isInstituicaoNome() {
        return instituicaoNome;
    }

    public void setInstituicaoNome(boolean instituicaoNome) {
        this.instituicaoNome = instituicaoNome;
    }

    public String getModalidade() {
        return modalidade;
    }

    public void setModalidade(String modalidade) {
        this.modalidade = modalidade;
    }

    public String getInstituicao() {
        return instituicao;
    }

    public void setInstituicao(String instituicao) {
        this.instituicao = instituicao;
    }

    public Projeto getProjetoSelecionado() {
        return projetoSelecionado;
    }

    public void setProjetoSelecionado(Projeto projetoSelecionado) {
        this.projetoSelecionado = projetoSelecionado;
    }
    
}
