/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package webServices;

import com.google.gson.Gson;
import dao.ImagemSegmentadaDAO;
import dao.ObjetoDAO;
import java.util.ArrayList;
import java.util.List;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.UriInfo;
import javax.ws.rs.PathParam;
import javax.ws.rs.Consumes;
import javax.ws.rs.Produces;
import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.PUT;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;
import modelos.ImagemOriginal;
import modelos.ImagemSegmentada;
import modelos.ObjetoSegmentado;
import modelos.Ponto;
import modelos.Usuario;

/**
 * REST Web Service
 *
 * @author DanielDruszcz
 */
@Path("imagem")
public class ImagemWS {

    @Context
    private UriInfo context;

    @POST
    @Path("/{id_imagem}/usuario/{id_usuario}/marcacoes/{marcacoes}/comentario/{comentario}")
    @Consumes(MediaType.APPLICATION_JSON)
    public Response post(@PathParam("id_imagem") int idImagem , @PathParam("marcacoes") String marcacoes , @PathParam("id_usuario") int idUsuario , @PathParam("comentario") String comentario){
        ImagemOriginal imagemOriginal = new ImagemOriginal();
        imagemOriginal.setId(idImagem);
        Usuario usuario = new Usuario(idUsuario);
        ImagemSegmentada imagemSegmentada = new ImagemSegmentada();
        imagemSegmentada.setImagemOriginal(imagemOriginal);
        imagemSegmentada.setUsuario(usuario);
        imagemSegmentada.setComentario(comentario);
        long idImagemSegmentada = new ImagemSegmentadaDAO().cadastra(imagemSegmentada);
        List<ObjetoSegmentado> listaMarcacoes = remontaPontos(marcacoes);
        for(ObjetoSegmentado o : listaMarcacoes)
            System.out.println(o);
        new ObjetoDAO().salvaMarcacoes(listaMarcacoes, idImagemSegmentada);
        return Response.ok().header("Access-Control-Allow-Origin", "*").build();
    }

    private List<ObjetoSegmentado> remontaPontos(String marcacoes){
        ArrayList<ObjetoSegmentado> objetosMarcados = new ArrayList<>();
        String[] arrayMarcacoes = marcacoes.split("_");
        for(int c = 0 ; c < arrayMarcacoes.length ; c++){
            String[] objeto = arrayMarcacoes[c].split(" ");
            ObjetoSegmentado objetoSegmentado = new ObjetoSegmentado();
            for(int x = 1 ; x < objeto.length - 1 ; x++){
                String[] pontos = objeto[x].split(",");
                Ponto p = new Ponto();
                p.setOrdem(x);
                p.setEixoX(Integer.valueOf(pontos[0]));
                p.setEixoY(Integer.valueOf(pontos[1]));
                objetoSegmentado.addPonto(p);
            }
            objetoSegmentado.setNumPontos(objetoSegmentado.getPontos().size());
            objetosMarcados.add(objetoSegmentado);    // essa lista vai para uma dao que salva tudo no banco
        }
        return objetosMarcados;
    }
    
    @GET
    @Path("/pontos/{id_imagem}")
    @Produces(MediaType.APPLICATION_JSON)
    public Response pegaPontos(@PathParam("id_imagem") int idImagem){
        String json = new Gson().toJson(new ObjetoDAO().listaMarcacoes(idImagem));
        return Response.ok(json , MediaType.APPLICATION_JSON).header("Access-Control-Allow-Origin", "*").build();
    }

    @GET
    @Path("/{id_imagem}")
    @Produces(MediaType.APPLICATION_JSON)
    public Response teste(@PathParam("id_imagem") long idImagem){
        String json = new Gson().toJson(new ImagemSegmentadaDAO().pegaDados(new ImagemSegmentada(idImagem)));
        return Response.ok(json , MediaType.APPLICATION_JSON).header("Access-Control-Allow-Origin", "*").build();
    }
}
